var g_imageLocal=null;
var g_audioLocal=null;
var g_bFaileLoad=false;

function DownloadPreviewToLocalStorage(_remoteFile) {
		if(g_Version=='webapp')
			return;
		if(GetOSType()=='ios'){
			var remoteFile = _remoteFile
			var localFileName = "preview.jpg";
			g_imageLocal=null;
			
			window.requestFileSystem(LocalFileSystem.TEMPORARY, 0, function(fileSystem) {
					fileSystem.root.getFile(localFileName, {create: true, exclusive: false}, 
					function(fileEntry) {
						var localPath = fileEntry.toURL();
						//alert(localPath);
						var ft = new FileTransfer();
						ft.onprogress  = function(progressEvent){
							HideLoader();
						};
						ft.download(remoteFile,
							localPath, function(entry) {
								g_imageLocal = entry.toNativeURL();
								//alert("Success "+g_imageLocal);
							}, failedDownload);
					}, failedDownload);
			}, failedDownload);
		}
		else
		if(GetOSType()=='android'){
			var remoteFile = _remoteFile
			var localFileName = "preview.jpg";
			var localDir = "com.alerte511";
		  //  alert(remoteFile+" TO "+localDir+"/"+localFileName);
			g_imageLocal=null;
			
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
				fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {
					fileSystem.root.getFile(localDir+"/"+localFileName, {create: true, exclusive: false}, 
					function(fileEntry) {
						var localPath = fileEntry.toURL();
						//alert(localPath);
						var ft = new FileTransfer();
						ft.onprogress  = function(progressEvent){
							HideLoader();
						};
						ft.download(remoteFile,
							localPath, function(entry) {
								g_imageLocal = entry.toNativeURL();
								//alert("Success "+g_imageLocal);
							}, failedDownload);
					}, failedDownload);
				}, failedDownload);
			}, failedDownload);
		}
}
function DownloadAvatarToLocalStorage(_remoteFile,_foo) {
		if(g_Version=='webapp')
			return;
		//alert(_remoteFile);
		if(GetOSType()=='ios'){
			var remoteFile = _remoteFile
			var localFileName = "avatar.jpg";
			//alert(remoteFile+" TO "+localFileName);
			g_imageLocal=null;
			//DisplayLoader("Un moment svp!");
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
					
					fileSystem.root.getFile(localFileName, {create: true, exclusive: false}, function(fileEntry) {
						var localPath = fileEntry.toURL();
						var ft = new FileTransfer();
						ft.onprogress  = function(progressEvent){
							HideLoader();
						};
						ft.download(remoteFile,
							localPath, function(entry) {
								//alert("Download Success "+entry.toNativeURL());
								g_userProfil.avatar = entry.toNativeURL();
								if(_foo!=null) _foo.call();
								
							}, failedDownload);
					}, failedDownload);
			}, failedDownload);
		}
		else
		if(GetOSType()=='android'){
			var remoteFile = _remoteFile
			var localFileName = "avatar.jpg";
			var localDir = "com.alerte511";
			//alert(remoteFile+" TO "+localFileName);
			g_imageLocal=null;
			//DisplayLoader("Un moment svp!");
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
				fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {
					fileSystem.root.getFile(localDir+"/"+localFileName, {create: true, exclusive: false}, function(fileEntry) {
						var localPath = fileEntry.toURL();
						//alert('DownloadAvatar '+localPath);
						var ft = new FileTransfer();
						ft.onprogress  = function(progressEvent){
							HideLoader();
						};
						ft.download(remoteFile,
							localPath, function(entry) {
								//alert("Download Success "+entry.toNativeURL());
								g_userProfil.avatar = entry.toNativeURL();
								if(_foo!=null) _foo.call();
								
							}, failedDownload);
					}, failedDownload);
				}, failedDownload);
			}, failedDownload);
		}
}
function failedDownload(error) {
	g_bFaileLoad=true;
    //alert("Error "+error.code);
}
function DownloadMP3ListToLocalStorage(_index,_audioList,_foo) {
		//alert(_remoteFile);
		if(g_Version=='webapp'){
			if(_foo!=null)
				_foo.call();
			return;
		}	
 		if(_audioList==null || _index>=_audioList.length){
			//alert("Failed Loading");
			if(_foo!=null)
				_foo.call();
			return;
		}	
        var localDir = "com.alerte511";
		var remoteFile = _audioList[_index];
		var filename = remoteFile.replace(/^.*[\\\/]/, '');
		var localeFile = localDir+"/"+filename; //localDir+"/audio"+_index+'.mp3';
		//alert("Loading "+localeFile);
		//DisplayLoader("Un moment svp!");
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
			fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {
					fileSystem.root.getFile(localeFile,{create: false},
						//Just get file if it exist
						function(fileEntry){
							var localPath = fileEntry.toNativeURL();//+"/"+localeFile;
							//alert('Old '+localPath);
							_audioList[_index]=localPath;
							DownloadMP3ListToLocalStorage(_index+1,_audioList,_foo);
						},
						//Download it if it does not exist
						function(){
							fileSystem.root.getFile(
								localeFile, 
								{create: true, exclusive: false}, 
								function(fileEntry) {
									var localPath = fileEntry.toURL();
									//alert('New '+localPath);
									var ft = new FileTransfer();
									ft.onprogress  = function(progressEvent){
										HideLoader();
									};
									ft.download(remoteFile,
										localPath, 
										function(entry) {
											//alert("Success "+entry.toURL());
											_audioList[_index]=entry.toNativeURL();
											DownloadMP3ListToLocalStorage(_index+1,_audioList,_foo);
										}, failedMP3Download);
								},failedMP3Download);
						});
            }, failedMP3Download);
        }, failedMP3Download);
}
function DownloadMP3ToLocalStorage(_audioFile,_foo) {

		if(g_Version=='webapp'){
			if(_foo!=null)
				_foo(_audioFile);
			return;
		}	
        var localDir = "com.alerte511";
		var remoteFile = _audioFile;
		var filename = remoteFile.replace(/^.*[\\\/]/, '');
		var localeFile = filename; //localDir+"/audio"+_index+'.mp3';
		//alert("FROM "+remoteFile+' TO '+localeFile);
		//DisplayLoader("Un moment svp!");
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
		fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {
					fileSystem.root.getFile(localeFile,{create: false},
						//Just get file if it exist
						function(fileEntry){
							var localPath = fileEntry.toNativeURL(); //+"/"+localeFile;
							//alert('Old '+localPath);
							
							if(_foo!=null) _foo.call(this,localPath);
							
						},
						//Download it if it does not exist
						function(){
							fileSystem.root.getFile(
								localeFile, 
								{create: true, exclusive: false}, 
								function(fileEntry) {
									var localPath = fileEntry.toURL();
									//alert('New '+localPath);
									var ft = new FileTransfer();
									ft.download(remoteFile,
										localPath, 
										function(entry) {
											var localPath = entry.toNativeURL();
											//alert("Success "+localPath);
											if(_foo!=null) _foo.call(this,localPath);
										}, failedMP3Download);
									
								},failedMP3Download);
						});
            }, failedMP3Download);
        }, failedMP3Download);
}
         
function failedMP3Download(error) {
	//alert("DOWNLOAD MP3 ERROR SOURCE " + error.source+" TARGET " + error.target+" CODE " + error.code);
}
function DownloadJPGListToLocalStorage(_index,_imageList,_foo) {
		if(g_Version=='webapp'){
			if(_foo!=null)
				_foo();
			return;
		}	
		if(_imageList==null || _index>=_imageList.length){
			//alert("Failed Loading");
			if(_foo!=null)
				_foo();
			return;
		}	
        var localDir = "com.alerte511";
		var remoteFile = _imageList[_index];
		var localeFile = localDir+"/image"+_index+'.jpg';
		//alert("Load "+remoteFile+" To "+localeFile);
		if(remoteFile=='none'){
			DownloadJPGListToLocalStorage(_index+1,_imageList,_foo);
		}
		else{
			//alert("Loading "+remoteFile);
			//DisplayLoader("Un moment svp!");
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
				fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {
						//Download file
						fileSystem.root.getFile(localeFile, {create: true, exclusive: false}, function(fileEntry) {
							var localPath = fileEntry.toURL();
							//alert(localPath);
							var ft = new FileTransfer();
							ft.onprogress  = function(progressEvent){
								HideLoader();
							};
							ft.download(remoteFile,
								localPath, function(entry) {
									//alert("Success "+entry.toNativeURL());
									_imageList[_index]=entry.toNativeURL();
									DownloadJPGListToLocalStorage(_index+1,_imageList,_foo);
								}, failedJPGDownload);
						}, failedJPGDownload);
				}, failedJPGDownload);
			}, failedJPGDownload);
		}
}
        
function failedJPGDownload(error) {
	//alert("DOWNLOAD JPG ERROR SOURCE " + error.source+" TARGET " + error.target+" CODE " + error.code);

}

