
/* camera capture player */

var g_FileLocalFilename=null;
var g_FileRemoteFilename=null;
var g_PictureLocalFilename=null;
var g_PictureRemoteFilename=null;
var g_uploadPictureStatus='end';
var g_uploadPictureTry=0;
var g_uploadPath=0;;
var g_timerPictureHandle=0;
var g_captureType;

function capturePhoto() {

	//Get picture
	g_captureType='photo';
	setTimeout(function(){navigator.camera.getPicture(photoSuccess,photoFail,
		{
		quality:50,
		targetWidth:320,
		saveToPhotoAlbum:true,
		correctOrientation:true,
		destinationType: navigator.camera.DestinationType.FILE_URI
		});},500);
}
function captureFile() {

	g_captureType='file';
	setTimeout(function(){navigator.camera.getPicture(photoSuccess,photoFail,
	{
		sourceType:0,
		destinationType:1,
		allowEdit:true,
		quality:50,
		targetWidth:320,
		destinationType: navigator.camera.DestinationType.FILE_URI

	});},500);	
	
}


function photoSuccess(imageFilename) {


	HideLoader();
	if(g_captureType=='file'){
		SetFileBtn(true);
		SetPictureBtn(false);
	}
	else{
		SetFileBtn(false);
		SetPictureBtn(true);
	}
	
	
	//alert(imageFilename);
	if(GetOSType()=='ios'){
		//alert(imageFilename);
		g_PictureLocalFilename = imageFilename;
		//Display image
		var imgPlayer = document.getElementById('imagePlayer3');
		imgPlayer.src = g_PictureLocalFilename;
	}
	else
	if(GetOSType()=='android'){
		window.resolveLocalFileSystemURI(imageFilename, function(fileEntry){
		
			var localDir = "com.alerte511";
			var localFileName=  "user_picture.jpg";
			//Display image
			var imgPlayer = document.getElementById('imagePlayer3');
			imgPlayer.src = fileEntry.toNativeURL();
			
			window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) { 
				fileSystem.root.getDirectory(localDir, {create: true, exclusive: false}, function(dir) {
					fileSystem.root.getFile(localDir+'/'+localFileName, {create: true, exclusive: false}, 
						function(newFileEntry) {
								g_PictureLocalFilename=newFileEntry.toNativeURL();
								//alert(g_PictureLocalFilename);
								fileEntry.copyTo(dir, localFileName, function(fileCopy){
									
								}, failPictureCopy);
						},failPictureCopy);
					}, failPictureCopy); 
			}, failPictureCopy); 
		},failPictureCopy);
	}
}
function failPictureCopy(error) {
		//alert(" ERROR CODE " + error.code);
}
function photoFail(error) {
	g_PictureLocalFilename=null;
	HideLoader();
	//SetPictureBtn(false);

	//alert("An error has occurred: Code = " + error);
	//console.log("upload error source " + error.source);
	//console.log("upload error target " + error.target);
}

function uploadPictureFile(_ft,_file,_foo) {

 	if(_file==null){
		g_uploadPictureStatus='end';
		if(_foo!=null) _foo.call();
		return;
	}
	var urlExt = g_serverID+"phpservices/UploadPicture.php";
	var path ='/'+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder;

	//alert('uploadPicture '+_file);

	//Set uplaod options
    options = new FileUploadOptions();
	options.fileKey="file";
	options.fileName=_file.substr(_file.lastIndexOf('/')+1);
	options.mimeType="image/jpg";
	
	params = new Object();
    params.value1 = path;
    options.params = params;
	options.chunkedMode=true;
	options.headers={"Connection":"close"};
	
	g_uploadPictureStatus='start';
	

	//Upload file to server
	_ft.onprogress = function(progressEvent){
		//Clear reset timer
		if(g_uploadPictureTry==0){
			//var loaded_ratio = progressEvent.loaded/progressEvent.total;
			//alert('Picture ' + loaded_ratio);
			g_uploadPictureTry=1;
			g_timerPictureHandle = setTimeout(function(){
				_ft.abort();
				uploadPictureFile(_ft,_file,_foo); 
			},2000);
		}
	};
	

 	_ft.upload(_file, urlExt, function(r){
		if(g_timerPictureHandle!=0)
			clearTimeout(g_timerPictureHandle);
		g_timerPictureHandle=0;
		//alert('Picture '+r.response+' Code '+r.responseCode);
		g_PictureRemoteFilename= r.response;
		g_uploadPictureStatus='end';
		if(_foo!=null) _foo.call();
		
	}, uploadPictureFailed, options,true);
	

}
function uploadPictureSuccess(r) {
	
	g_PictureRemoteFilename= r.response;
	g_uploadPictureStatus='end';
	//alert('PictureFile '+g_PictureRemoteFilename);
	
}
function uploadPictureFailed(error) {
	g_disableRefresh=true;
	return;
	/*
	var msgText;
	 switch(error.code) {
	 case FileTransferError.FILE_NOT_FOUND_ERR:
		msgText = "File not found.";
	 break;
	 case FileTransferError.INVALID_URL_ERR:
		msgText = "Invalid URL.";
	 break;
	 case FileTransferError.CONNECTION_ERR:
		msgText = "Connection error.";
	 break;
	 default:
		msgText = "Unknown error.";
	}
	//Now tell the user what happened
	alert(msgText+' SRC '+error.source+" TARGET " + error.target+" CODE " + error.code);
	*/
}
