
var g_audioPlayerList = new Array();
var g_imageList = new Array();
var g_camIDPlayerList = new Array();
var g_audioPlayer=0;
var g_recordPlayer=0;
var g_streamPlayer=0;

var g_playListIndex=-1;
var g_timeoutValue=2000;
var g_playListLength=0;
var g_nbrWait=0;
var g_playListStatus='none';
var g_firstVideo=true;
var g_waitTimer=0;
var g_lastVideoIndex=-1;
var g_waitTimerHandle=0;
var g_streamURL=0;
var g_streamPlaying=false;
/*  ======================================================================================================================================================================
Display the camera preview video and informations from the receiving camera id (ex. Q0001)
Informations :
Direction (ex. Direction Nord)
Description	(ex. � la hauteur de ....)
====================================================================================================================================================================== */

function InitAudioPlayer() {
	var audioPlayer;
	
	//Save audio files in queue
	g_playListStatus='Init';
	g_playListLength = 0;
	g_audioPlayer =  AllocAudioPlayer('#audioPlayList');
	//Add end event for playback
	g_audioPlayer.setEnded(function() { 
			//alert("START "+g_playListIndex+"/"+g_playListLength+" Status "+g_playListStatus);
			if(g_playListStatus!='stop'){
				g_playListIndex++;
				if(g_playListIndex<g_playListLength){
					PlayAudioVideo(g_playListIndex);
				}
				else{
					StopAudioPlayer();
					PlayAllUserMessage(function(){ShowPrevPage();});
				}
			}
				
	});	
	//Recording message player
	g_recordPlayer =  AllocAudioPlayer('#recordPlayer');
	g_streamPlayer =  AllocAudioPlayer('#audioStream');
	g_audioPlayerList=[];
	g_imageList=[];
	g_camIDList=[];
	

}

function PlayAudioVideoList(_audioList,_videoList,_showPage) {
	//Clear previous playlsit
	var i;
	var videoPlayer;
	
	//Display faile message in case of bad internet connection

	
	g_audioPlayerList=[];
	g_imageList=[];
	g_camIDList=[];
	
	//Save audio files in queue
	g_playListStatus='Loading';
	g_playListLength = _audioList.length;
	//Download audio files
	for(i=0;i<_audioList.length ;i++){
		var srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/" + _audioList[i] + ".mp3";
		g_audioPlayerList.push(srcFilename)
	}
	g_firstVideo=true;
	g_lastVideoIndex=-1;
	//Save video files in queue
	var imageURL;
	for(i=0;i<_videoList.length ;i++){
		if(_videoList[i]!='none')
			imageURL =   g_serverID+g_dataDirectory+"/IMAGES" + g_sInputIndex + "/" + _videoList[i] + ".jpg";
		else
			imageURL =   _videoList[i];
		g_imageList.push(imageURL);
		g_camIDList.push(_videoList[i]);
	}

	//Show preview page
	//DisplayWelcomeImage();
	//if(_showPage==true)
	//	ShowPage('bulletin');
	//alert('PlayAudioVideoList');
	//DisplayLoader("Un moment svp...");
	
	//Download playlit to local storage
	DownloadMP3ListToLocalStorage(0,g_audioPlayerList,function(){
		DownloadJPGListToLocalStorage(0,g_imageList,function(){
			//HideLoader();
			
			g_playListIndex=0
			g_playListStatus='Playing'
			
			//Start playing playlist
			g_audioPlayer.crop(0.1,0.4);
			g_audioPlayer.setReturnToMap(true);
	
			PlayAudioVideo(g_playListIndex);
		});
	});

}
function PlayAudioList(_audioList) {
	//Clear previous playlsit
	var i;
	
	g_audioPlayerList=[];
	
	//Save audio files in queue
	g_playListStatus='Loading';
	g_playListLength = _audioList.length;
	//console.println("Loading "+g_playListLength);
	for(i=0;i<_audioList.length ;i++){
		g_audioPlayerList.push(_audioList[i]);
	}
	
	g_audioPlayer.setReturnToMap(true);

	PlayAudioVideo(g_playListIndex);
	

}

function PlayRecordAudio(_audioFilename,_foo){

	var mediaFile =  {
			mp3: _audioFilename
	};
	g_recordPlayer.setMedia(mediaFile);
	g_recordPlayer.setEnded(function() { 
		 if(_foo!=null) _foo.call();
	});

}
function StopRecordAudio(){
	g_recordPlayer.pause();
	g_recordPlayer.clearMedia();
	//alert('StopRecordAudio');
}
function AllocAudioPlayer(_divID){

		var options = {
			errorAlerts:false,
			volume:1,
			swfPath: "js",
			supplied: "mp3",
			solution: 'html,flash',
			wmode: "window"

		};

		//Create player and assign to div element
		var mediaFile =  {};
		var audioPlayer = new jPlayer('audio','',_divID, mediaFile,options); 
			
		return audioPlayer;
	

}

function PlayAudioVideo(_index){

	if(g_waitTimerHandle!=0)
		clearTimeout(g_waitTimerHandle);
	g_waitTimerHandle=0;
	g_waitTimerHandle = setTimeout(function(){DisplayLoader("Un moment svp...");},3000);
	
	var audioFilename = g_audioPlayerList[_index];
	//alert('Playing '+audioFilename);
	var mediaFile =  {
			mp3: audioFilename
		//	oga: "http://www.alerte511.com/OGG/" + g_audioPlayerList[_index] + ".ogg"
	};

	g_audioPlayer.setMedia(mediaFile);
	

	if(g_imageList[_index]!='none'){
		ShowImageBulletin(g_camIDList[_index],g_imageList[_index]);
		g_lastVideoIndex=_index;
		
	}

}

function StopAudioPlayer() {

	g_playListStatus='stop';
	g_audioPlayer.pause();
	
	g_audioPlayerList = [];
	g_camIDList = [];
	g_imageList = [];
	g_playListIndex=-1;
	
	g_bRegionalBulletinPlaying=false;
	g_bLocalBulletinPlaying=false;
	g_bRegionalBulletinMode=false;

	
}

function SetAudioStream(_audioURL){
	g_streamURL=_audioURL;
}

function PlayAudioStream(){

	if(g_streamURL!=0 ){
		DisplayLoader("Un moment svp...");

		var mediaFile =  {
				mp3: g_streamURL
			//	oga: g_streamURL
		};
		g_streamPlayer.crop(0,0);
		g_streamPlayer.setMedia(mediaFile);	
		g_streamPlaying=true;
		
	}
	
}

function PauseAudioStream(_pause){

	if(g_streamPlaying==false)
		return;
	if(g_streamPlayer!=0 ){
		if(_pause==true && g_streamPlaying==true){
			g_streamPlayer.clearMedia();
			//HideLoader();
		}
		else
		if(_pause==false){
			PlayAudioStream();
		}
	}
}
function StopAudioStream(){

	if(g_streamPlayer!=0 && g_streamPlaying==true){
		g_streamPlayer.clearMedia();
		g_streamPlaying=false;
		//HideLoader();
	}
}

var jPlayer = (function($) {
	var fix = function(type,nameId,divId,media, options) {
	
		this.playFix = false;
		this.init(type,nameId,divId,media, options);
	};
	fix.prototype = {
		init: function(type, nameId,divId,media,options) {
			var self = this;
			// Store the params
			this.type = type;
			this.nameId = nameId;
			this.divId = divId;
			this.options = options;
			this.foo=null;
			this.canPlayFlag=false;
			this.media=media;
			this.status='init';
			this.cropBegin=0;
			this.cropEnd=0;
			this.returnToMap=true;
			
			// Make a jQuery selector of the divId, for use by the jPlayer instance.
			this.player = $(this.divId);
			
			// Make the ready event to set the media to initiate.
			this.player.bind($.jPlayer.event.ready, function(event) {
				//alert("ready "+self.media.mp3 );
				//$(this).jPlayer("setMedia", self.media);
				//if(!$.jPlayer.platform.mobile && !$.jPlayer.platform.tablet )
				self.canPlayFlag=true;	
				
			});
					
			this.player.bind($.jPlayer.event.progress, function(event) {
				//console.println("loading "+self.media.mp3 );
			});
			// Fix missing ended events.
			this.player.bind($.jPlayer.event.ended, function(event) {
				//console.println("ended " +self.media.mp3);
				//if(self.foo!=null && self.status=='pause') self.foo.call();
				self.status='ended';
				//alert("ended " +self.media.mp3);
				//if(self.type=='video' ) 

			});
			this.player.bind($.jPlayer.event.pause, function(event) {
				//alert("pause "+self.media.mp3 );

				if(self.foo!=null ) self.foo.call();
				//self.status='pause';
				//if(self.type=='video' ) 
				self.canPlayFlag=true;
				
			});
			this.player.bind($.jPlayer.event.play, function(event) {
				self.status='play';
				//HideLoader();
				if(g_waitTimerHandle!=0)
					clearTimeout(g_waitTimerHandle);
				g_waitTimerHandle=0;
				//alert("play "+self.media.mp3 );


			});
			this.player.bind($.jPlayer.event.canplaythrough, function(event) {
				//alert("canplaythrough "+self.media.mp3 );
				$(this).jPlayer('play');
				
				
			});	
			//Use timeupdate to display corectly on Android phone
            this.player.bind($.jPlayer.event.timeupdate , function(event) { 
			//Stop 0.5 sec before end
				var timestamp = (event.jPlayer.status.currentTime);
				var duration = (event.jPlayer.status.duration);
				//console.println(timestamp+"/"+duration);
				if(this.cropBegin>0 && this.cropEnd>0 && timestamp>this.cropBegin && timestamp>=duration-this.cropEnd){
					$(this).jPlayer("pause");
				}
				
			}); 
			this.player.bind($.jPlayer.event.error, function(event) {
				//alert(event.jPlayer.error.type);
				//if(self.canPlayFlag==true ) {
					// Setup the media stream again and play it.
				//	$(this).jPlayer("setMedia", self.media);
				//}
			});
			// Instance jPlayer
			this.player.jPlayer(this.options);
			// Store a local copy of the jPlayer instance's object
			this.jPlayer = this.player.data('jPlayer');
			// Store the real cssSelectorAncestor being used.
			this.cssSelectorAncestor = this.player.jPlayer('option', 'cssSelectorAncestor');
			return this;
		},
		setMedia: function(media) {
			this.media=media;
			// Set the media
			this.player.jPlayer("setMedia", media);
			//alert('setMedia '+media.mp3);
			return this;
		},
		play: function() {

			// Set the media
			this.player.jPlayer("play",0);
		},
		load: function() {

			this.player.jPlayer("load");
		},

		setEnded: function(_foo) {
			//memorize ended function
			this.foo=_foo;

		},
		pause: function(){
			this.player.jPlayer("pause"); 
		},
		stop: function(){
			this.player.jPlayer("stop"); 
		},
		clearMedia: function(){
			this.player.jPlayer("clearMedia"); 
		},
		reloadMedia: function(){
			this.player.jPlayer("clearMedia"); 
			this.player.jPlayer("setMedia", this.media); 
		},
		preload: function(){
			if($.jPlayer.platform.android || $.jPlayer.platform.iPhone ) {
				this.player.jPlayer("play",0.1);
				this.player.jPlayer("pause");
			}
		},
		destroy: function(){
			this.player.jPlayer("destroy"); 
		},
		getStatus: function(){
			return this.status; 
		},
		setReturnToMap: function(_value){
			this.returnToMap=_value; 
		},
		getReturnToMap: function(){
			return this.returnToMap; 
		},
		crop: function(_begin,_end){
			this.cropBegin = _begin; 
			this.cropEnd = _end; 
		},
		getOS: function(){
			if($.jPlayer.platform.android)
				return 'android';
			else
			if($.jPlayer.platform.iphone || $.jPlayer.platform.ipod  || $.jPlayer.platform.ipad) 
				return 'ios';
			else
				return 'unknown';
		}
	};
	return fix;
})(jQuery);
