var g_currentCamID=0;
var g_displayIndex;
var g_TimerHandle = 0;
var g_firstError;
var g_secondError;
var g_firstVideoURL;
var g_secondVideoURL;
var g_bVideoInit = false;
var g_imageURL;
var g_showBtnPlay=false;
var g_indexVideo=0;
var g_VideoElement=0;
var g_autoStart=false;
var g_bVideoPlayerInit = false;
var g_bVideoPlaying=false;
var g_bVideoStarted=false;
var videoPlayer;
var g_waitTimer=0;
var g_displayType='image';
var g_waitHandle=0;
var bToggleFavorite=0;
var g_Status;
var g_VideoURL;
var g_pubList = new Array();
var g_pubindex=0;


function Pub(_file,_link) {
    this.file = _file;
    this.link = _link;
 }
/*  ======================================================================================================================================================================
Display the camera preview video and informations from the receiving camera id (ex. Q0001)
Informations :
Direction (ex. Direction Nord)
Description	(ex. à la hauteur de ....)
====================================================================================================================================================================== */


function ShowImagePreview(camId) {

	if(g_currentCamID != camId)
		StartWaitTimer(1.0);

    g_currentCamID = camId;
    g_displayIndex = camerasMap[camId].index;
	
	
	//Display image panel
	DisplayImagePanel();

	//Display info box
	DisplayInfoBox(g_currentCamID);
	
	//Display ctrl arrows
	DisplayCtrl();
	
	//Display image
    var timesamp = Date.now();
	g_imageURL =   g_serverID+g_dataDirectory+"/IMAGES" + g_sInputIndex + "/" + g_currentCamID + ".jpg"+"?"+timesamp;
	//g_VideoURL = camerasMap[camId].urlVideo;
	g_VideoURL =  g_serverID+g_dataDirectory+"/VIDEO" + g_sInputIndex + "/" + camId + ".mp4";

	//Download image for social share
	//if(g_Version!='webapp')
	DownloadPreviewToLocalStorage(g_imageURL);
	//DownloadPreviewToLocalStorage(g_VideoURL);
	
	var imgPlayer = document.getElementById('imagePlayer');
	imgPlayer.src = g_imageURL;
	g_showBtnPlay=true;
	
}
function ShowImageBulletin(_camID,_imageURL) {

	if(_imageURL=='none'){
		DisplayWelcomeImage();
		return;
    }
	//g_currentCamID = camId;
    //g_displayIndex = camerasMap[camId].index;
	
	//StartWaitTimer(1);
	
	//
	//Display info box
	DisplayInfoBox(_camID);
	
	
	//Display image
	//alert(g_imageURL);
	var imgPlayer =0;
	var imgPlayer = document.getElementById('imagePlayer2');
	imgPlayer.src = _imageURL;
	g_showBtnPlay=true;
	//alert(_imageURL);

}

function ShowVideoPreview(camId) {

	//alert("ShowVideoPreview");
	//if(g_bLocalBulletinPlaying==true || g_bRegionalBulletinPlaying==true){
	//	DisplayError("La vidéo ne peut pas jouer durant le bulletin. Essayez plus tard.");
	//	return;
	//}
		
    g_currentCamID = camId;
    g_displayIndex = camerasMap[camId].index;

	StartWaitTimer(0.5);

    //Display info box
    DisplayInfoBox(camId);
	
	//Stop video if it is running

	if (g_bVideoPlayerInit == true  ){
		StopVideoPlayer();
	}
	
	//Load video while showing grab image
	g_firstVideoURL =  g_serverID+g_dataDirectory+"/VIDEO" + g_sInputIndex + "/" + camId + ".mp4";
	//alert(g_firstVideoURL);
	//g_firstVideoURL = camerasMap[camId].urlVideo;

	g_secondVideoURL = camerasMap[camId].urlVideo;
	//Restart next video
	g_firstError = false;
	g_secondError = false;
	g_autoStart=true;
	//Load video panel
	//DisplayVideoPanel();
	//alert(camId);
	LoadVideo(g_firstVideoURL,g_imageURL);
	PlayVideo();



}
function ShowUserVideoPreview(_videoURL)
{

	StartWaitTimer(0.5);
	
	//Stop video if it is running
	if (g_bVideoPlayerInit == true  ){
		StopVideoPlayer();
	}
	
	//Restart next video
	g_firstError = false;
	g_secondError = false;
	g_autoStart=true;
	//Load video panel
	//DisplayVideoPanel();
	g_firstVideoURL=_videoURL;
	//alert(g_firstVideoURL);
	LoadVideo(g_firstVideoURL,g_imageURL);
	PlayVideo();

}


/*  ======================================================================================================================================================================
Display the camera preview video and informations from the receiving camera id (ex. Q0001)
Informations :
Direction (ex. Direction Nord)
Description	(ex. à la hauteur de ....)
====================================================================================================================================================================== */

function DisplayInfoBox(_camID) {

    //alert(_camID);
    // Set Camera Infos
	//alert(camerasMap[_camID].iconURL);
    $('#pnlCameraPreviewPage #icon').attr("src", camerasMap[_camID].iconURL);
    $('#pnlCameraPreviewPage span#route').text(camerasMap[_camID].surname + "(" + camerasMap[_camID].route + ")");
	$('#pnlCameraPreviewPage span#description').text("");
    $('#pnlCameraPreviewPage span#description').text(camerasMap[_camID].description);
    $('#pnlCameraPreviewPage span#noteCam').text(camerasMap[_camID].trafficDirection);
   
	$('#pnlCameraBulletinPage #icon').attr("src", camerasMap[_camID].iconURL);
    $('#pnlCameraBulletinPage span#route').text(camerasMap[_camID].surname + "(" + camerasMap[_camID].route + ")");
	$('#pnlCameraBulletinPage span#description').text("");
    $('#pnlCameraBulletinPage span#description').text(camerasMap[_camID].description);
    $('#pnlCameraBulletinPage span#avatar2').attr("src","css/images/previewdirection.png");
    $('#pnlCameraBulletinPage span#userName').text('Alerte-511:');
	$('#pnlCameraBulletinPage span#noteCam').text(camerasMap[_camID].trafficDirection);

	//Set update time
	SetUpdate(cameraAlertsMap[_camID].date,cameraAlertsMap[_camID].time);



}
 
function DisplayCtrl() {
	var camera = camerasList[g_displayIndex];
	//alert(camera.id + " Est " + camera.est.length+" Ouest " + camera.ouest.length);
	if(camera.ouest.length>0)
		$('#divCtrlLayerLeft').removeClass().addClass('divCtrlLayerLeftOn');
	else
		$('#divCtrlLayerLeft').removeClass().addClass('divCtrlLayerLeftOff');
	if(camera.est.length>0)
		$('#divCtrlLayerRight').removeClass().addClass('divCtrlLayerRightOn');
	else
		$('#divCtrlLayerRight').removeClass().addClass('divCtrlLayerRightOff');
	if(camera.nord.length>0)
		$('#divCtrlLayerMiddleTop').removeClass().addClass('divCtrlLayerMiddleTopOn');
	else
		$('#divCtrlLayerMiddleTop').removeClass().addClass('divCtrlLayerMiddleTopOff');
	if(camera.sud.length>0)
		$('#divCtrlLayerMiddleBottom').removeClass().addClass('divCtrlLayerMiddleBottomOn');
	else
		$('#divCtrlLayerMiddleBottom').removeClass().addClass('divCtrlLayerMiddleBottomOff');

	if(camera.isFavorite==true)
		$('#btnFavorite').attr("data-theme", "a").removeClass("ui-btn-up-c").addClass("ui-btn-up-a");
	else
		$('#btnFavorite').attr("data-theme", "c").removeClass("ui-btn-up-a").addClass("ui-btn-up-c");
	
	//if(camera.isFavorite==true)
	//	$('#checkbox-favorite').prop('checked', true ).checkboxradio('refresh');
	//else
	//	$('#checkbox-favorite').prop('checked', false ).checkboxradio('refresh');
	
	//setTimeout(function(){$('#checkbox-favorite').checkboxradio('refresh');},100);

}

function InitVideoPlayer() {

   //alert("InitAudioPlayer");
	DisplayVideoPanel();
    
	g_VideoElement ="#videoPlayer";
	InitVideoElement(g_VideoElement);
    
	g_VideoElement ="#videoPlayer2";
	InitVideoElement(g_VideoElement);
	
	BindPreviewEvents();
	//setTimeout(function(){DisplayImagePanel();},2000);

}
function SetVideoPlayer(divID)
{
 	g_VideoElement =divID;
   // alert(g_VideoElement);
}

function InitVideoElement(divID) {

	var sizeVal;
	
	if($.jPlayer.platform.ipod || $.jPlayer.platform.iphone)
		sizeVal = { width: 1,height: 1};
	else
		sizeVal = { width: $(divID).width(),height: $(divID).height()};
    $(divID).jPlayer({
        ready: function() {
 
            $(this).bind($.jPlayer.event.canplaythrough, function(event) { 
				//alert("canplaythrough ");
			});
            $(this).bind($.jPlayer.event.play, function(event) { 
				g_bVideoPlaying=true;
				g_bVideoStarted=true;
				
				//alert(g_bVideoStarted)

			}); 			
			//Use timeupdate to display corectly on Android phone
            $(this).bind($.jPlayer.event.timeupdate , function(event) { 
				var percent = parseInt(event.jPlayer.status.currentPercentRelative);
				//alert(percent);
				if(g_bVideoStarted==true && percent>=5){
				//alert(percent);
					StopWaitTimer();
					DisplayVideoPanel();
					g_bVideoStarted=false;
				}

			}); 			

			$(this).bind($.jPlayer.event.ended, function(event) { 
				//alert("ended");
				//DisplayImagePanel(); 
				g_bVideoPlaying=false;
				//alert(g_bVideoPlaying);
			});            
			$(this).bind($.jPlayer.event.pause, function(event) { 
				//alert("pause");
				$(g_VideoElement).jPlayer("play",0);
				$(g_VideoElement).jPlayer("clearMedia");
				ExitFullscreen();
				//
				StopWaitTimer();
				if(g_secondError == false)
					DisplayImagePanel(); 
				g_bVideoPlaying=false;


				
			});
			
		
           $(this).bind($.jPlayer.event.error, function(event) {
               // alert(event.jPlayer.error.type + "\n" +
                //            event.jPlayer.error.context+ "\n" +
                //            event.jPlayer.error.message+ "\n" +
                //            event.jPlayer.error.hint);
                if (g_firstError == false) {
                   // alert("First Error");
                    g_firstError = true;
                    LoadVideo(g_secondVideoURL,g_imageURL);
					PlayVideo();
                }
                else
                    if (g_secondError == false) {
					StopWaitTimer();				//alert("Second Error");
                    g_secondError = true;
                    DisplayError("Vidéo non disponible.");
                }
				
					
            });
            //DisplayVideoPanel();
            
			g_bVideoPlayerInit = true;
			DisplayImagePanel();
  	
        },
		size: sizeVal,
		errorAlerts:false,
		emulateHtml:true,
		volume:1,
        swfPath: "js",
        supplied: "m4v",
        solution: 'html,flash'
    });
	//alert($(divID).width());
	//$("#jplayer_inspector").jPlayerInspector( {
	//			jPlayer: $("#videoPlayer"),
	//			visible: true
	//		});
			
}

function LoadVideo(_videoURL,_imageURL) {
   
    //Set URL
	//alert("LoadVideo ");
	g_bVideoPlaying=false;
	if(g_bVideoPlayerInit==true){
		var mediaFile = {
			m4v: _videoURL
		//	poster: _imageURL
		};
		$(g_VideoElement).jPlayer("setMedia",mediaFile); 
		//alert(_videoURL);
	}
 
}
function PlayVideo() {

    //Play video
	g_waitTimer=0;
	if(g_bVideoPlayerInit==true){
		//alert("PlayVideo ");
		setTimeout(function(){$(g_VideoElement).jPlayer("play");},1000);
	}


}
function ExitFullscreen() {
	if(g_bVideoPlayerInit==true ){
		//alert("Exit");	
		var video = $(g_VideoElement).data("jPlayer").htmlElement.video;
        video.webkitExitFullscreen();
		//$(g_VideoElement).jPlayer("clearMedia");
		//alert("Done");
	}
}
function StopVideoPlayer() {

    if (g_TimerHandle != 0) {
        clearTimeout(g_TimerHandle);
        if(g_bVideoPlayerInit==true && g_bVideoPlaying==true){
			//videoPlayer.pause();
			//$(g_VideoElement).jPlayer("stop");
			//$(g_VideoElement).jPlayer("clearMedia");
			//alert("StopVideoPlayer");
		}
    }
	//DisplayImagePanel(); 
	g_bVideoPlaying=false;
	g_TimerHandle = 0;
}

function WaitEndVideo(_foo){
	g_waitTimer++;
	//console.println("WaitVideo: "+g_waitTimer);
	if(g_bVideoPlaying==true && g_waitTimer<5){
		setTimeout(function(){WaitEndVideo(_foo);},1000);
	}
	else{
		if(g_waitTimer>=5)
			StopVideoPlayer();
		g_bVideoPlaying=false;
		if(_foo!=null){
			_foo.call();
			//alert("endedVideo");
		}
	}
}
function DisplayImagePanel() {
    
	if(g_displayType!='image'){
	//alert('DisplayImagePanel');
        if(g_VideoElement=="#videoPlayer"){
            $("#divVideoPlayer").css('z-index', '2'); 
            $('#divImagePlayer').css('z-index', '3');
            $('#divCtrlLayer').css('z-index', '4');
            $('.divWarningVideo').css('z-index', '4');
             $('.divErrorVideo').css('display', 'none');
        }
        else{
            $("#divUserVideoPlayer").css('z-index', '2'); 
            $('#divUserImage').css('z-index', '3');
            $('#divUserCtrlLayer').css('z-index', '4');
             $('.divWarningVideo').css('z-index', '4');
            $('.divErrorVideo').css('display', 'none');
        }
		g_displayType='image';
	}
   
   
}


function DisplayVideoPanel() {
   	if(g_displayType!='video'){
		//alert('DisplayVideoPanel');
	   if(g_VideoElement=="#videoPlayer"){
            $("#divVideoPlayer").css('z-index', '3'); 
            $('#divImagePlayer').css('z-index', '2');
            $('#divCtrlLayer').css('z-index', '1');
            $('.divWarningVideo').css('z-index', '1');
            $('.divErrorVideo').css('display', 'none');
       }
        else{
           $("#divUserVideoPlayer").css('z-index', '3'); 
            $('#divUserImage').css('z-index', '2');
            $('#divUserCtrlLayer').css('z-index', '1');
            $('.divWarningVideo').css('z-index', '1');
            $('.divErrorVideo').css('display', 'none');
           
        }
		g_displayType='video';
	}
}

function DisplayError(_text) {

    $('.divErrorVideo').css('display', 'block');
    $('.divErrorVideo').html(_text);
   	g_displayType='error';

       
}


function DisplayWelcomeAnimation(){
//Display welcom animation;
	var imgPlayer = document.getElementById('imagePlayer2');
	imgPlayer.src = "css/images/welcome.gif";
	$('#pnlCameraBulletinPage #icon').attr("src", "css/images/circleOrange.png");
    $('#pnlCameraBulletinPage span#route').text("Route");
	$('#pnlCameraBulletinPage span#description').text("à la hauteur de ...");
	$('#pnlCameraBulletinPage span#avatar2').attr("src","css/images/previewdirection.png");
    $('#pnlCameraBulletinPage span#userName').text("Alerte-511:");
    $('#pnlCameraBulletinPage span#noteCam').text("Les véhicules dans la voie la plus rapprochée de la caméra circulent en direction...");


}
function DisplayWelcomeImage(){
	//Display welcom animation;
	var imgPlayer = document.getElementById('imagePlayer2');
	imgPlayer.src = GetPublicityImage(); 
	$('.pnlCameraBulletinInfoBox').css('display','none');
 
}
function GetPublicityImage(){
	var pubImage;
	if(g_pubList.length>0){
		g_pubindex = g_pubindex+1;
		if(g_pubindex>=g_pubList.length)
			g_pubindex=0;
		pubImage = g_serverID+g_dataDirectory+"/NETWORKS/"+g_curNetwork+"/PUB/"+g_pubList[g_pubindex].file;
	}
	else
		pubImage = "css/images/splash320x240.png";
	return pubImage;
}
function LinkPub(){
	//Opne link to web browser
	window.open(g_pubList[g_pubindex].link,'_blank','location=no');
}
function DownloadPubList(_succes,_fail) {
		

        // All files has been load
		var dataString = "?path=" + g_dataDirectory +"/NETWORKS/"+g_curNetwork+"/PUB/publist.xml";
		var urlExt = g_serverID+"phpservices/GetXMLFile.php";
		$.ajax({
			type: "POST",
			url: urlExt+dataString,
			dataType: "xml",
			async: false,
			cache: false,
            success: function(xmlDoc) {
				g_pubList=[];
                var pubTag = xmlDoc.getElementsByTagName("Publicity");
                for (var i = 0; i < pubTag.length; i++) {
					//Get city attributes
                    var xmlAtt = pubTag[i].attributes;
                    var file = xmlAtt.getNamedItem("file").nodeValue;
                    var link = xmlAtt.getNamedItem("link").nodeValue;
					var new_pub = new Pub(file,link);
					g_pubList.push(new_pub);
				}
				g_pubindex=0;
				if(_succes!=null) _succes.call();
            },
			error:function (xhr, status, error){
				if(_fail!=null) _fail.call();
			}
        });
	
}
function BindPreviewEvents() {

  
	
	$('#imagePlayer').on('load',function() {
		StopWaitTimer();
	});
	$('#imagePlayer2').on('load',function() {
		StopWaitTimer();
	});
	
	$('#divCtrlLayerLeft').on('click',function() {
		//alert(camerasList[g_displayIndex].ouest);
		if(camerasList[g_displayIndex].ouest!=""){
			g_currentCamID=camerasList[g_displayIndex].ouest;
			ShowImagePreview(g_currentCamID);
		}

    });
	$('#divCtrlLayerRight').on('click',function() {
		if(camerasList[g_displayIndex].est!=""){
			g_currentCamID=camerasList[g_displayIndex].est;
			ShowImagePreview(g_currentCamID);
		}
    });
	$('#divCtrlLayerMiddleTop').on('click',function() {
		if(camerasList[g_displayIndex].nord!=""){
			g_currentCamID=camerasList[g_displayIndex].nord;
			ShowImagePreview(g_currentCamID);
		}
   });

	$('#divCtrlLayerMiddleBottom').on('click',function() {
		if(camerasList[g_displayIndex].sud!=""){
			g_currentCamID=camerasList[g_displayIndex].sud;
			ShowImagePreview(g_currentCamID);

		}

    });
		
	$('#btnFavorite').on('click',function() {
		//if(g_Version=="plus"){
			if(camerasList[g_displayIndex].isFavorite==true){
				SetLocalItem(camerasList[g_displayIndex].id,false);
				camerasList[g_displayIndex].isFavorite=false;
				$('#btnFavorite').buttonMarkup({theme: 'c'}); //.removeClass("ui-btn-up-a").addClass("ui-btn-up-b").attr("data-theme", "b");
			}
			else{
				SetLocalItem(camerasList[g_displayIndex].id,true);
				camerasList[g_displayIndex].isFavorite=true;
				$('#btnFavorite').buttonMarkup({theme: 'a'});//.removeClass("ui-btn-up-b").addClass("ui-btn-up-a").attr("data-theme", "a");
			}
		//}
		//else{
		//	DisplayVersionWarning();
		//	$('#checkbox-favorite').prop('checked', false);
		//}
    });
	
	$('#divCtrlLayerMiddleMiddle').on('click',function() {
		//alert(g_currentCamID);
		ShowVideoPreview(g_currentCamID);
    });	
	
	$('#btnPreviewShare').on('click',function() {
		DisplayCameraSocialShare();
    });
	$('#btnUserShare').on('click',function() {
		DisplayAlertSocialShare();
    });
	$('#btnPlayMessage').on('click',function() {
		//play audio
		if(g_editorInputList[g_AlertIndex].audioFile!=0 && g_editorInputList[g_AlertIndex].audioMute=='false'){
			var audiofile = g_serverID+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder+g_editorInputList[g_AlertIndex].audioFile;
			//alert(audiofile);
			PlayAudio(audiofile,null,null);
			
		}
    });
	$('#btnShareFacebook').on('click',function() {
		var roadname  = camerasMap[g_currentCamID].surname + "(" + camerasMap[g_currentCamID].route + ") " + camerasMap[g_currentCamID].description + ". ";
		shareFacebookLike(g_imageURL,roadname);
    });
	
	$('#btnShareTwitter').on('click',function() {
		var roadname  = camerasMap[g_currentCamID].surname + "(" + camerasMap[g_currentCamID].route + ") " + camerasMap[g_currentCamID].description + ". ";
		shareTwitter(g_imageURL,roadname);
    });
	
	$('#btnShareEmail').on('click',function() {
		var roadname  = camerasMap[g_currentCamID].surname + "(" + camerasMap[g_currentCamID].route + ") " + camerasMap[g_currentCamID].description + ". ";
		shareEmail(roadname,g_imageURL);
    });
		
}
function StartWaitTimer(_delay){
	g_waitHandle = setTimeout(function(){DisplayLoader("Un moment svp...");},_delay*1000);

}
function StopWaitTimer(){
	if(g_waitHandle!=0){
		clearTimeout(g_waitHandle);
		HideLoader();
		g_waitHandle=0;
	}
}
 