﻿
// user marker Contructor
function UserInput(userID,userName,userAvatar,roadID,direction,index,type,alertType, lat,lng,date,time,description,published,audioFile,audioMute,imageType,imageURL,cameraURL,filename) {
    this.userID = userID;
    this.userName = userName;
    this.userAvatar = userAvatar;
	this.roadID = roadID;
    this.direction = direction;
    this.index = index;
    this.type = type;
    this.alertType = alertType;
    this.tweet = "";
    this.lat = lat;
    this.lng = lng;
    this.date = date;
    this.time = time;
    this.description = description;
	this.published=published;
    this.audioFile = audioFile;
    this.audioMute = audioMute;
    this.filename = filename;
    this.imageURL = imageURL;
    this.cameraURL = cameraURL;
	this.imageType = imageType;
	this.read=false;
	this.marker=0;
    this.iconURL = 0;
    this.iconPinURL = 0;
    this.iconPressPinURL = 0;
}
var g_pubPath = 'PUB';
var g_editorPath = 'CUSTOM_RTT/USERS';
var g_userPath = 'CUSTOM_RTT/USERS';
var g_prevtime=0;
var g_prevInputLength=0;
var g_userInputUpdate=false;
var g_AlertIndex=-1;
var g_alertType=0;

var g_editorPrevInputList = new Array();
var g_editorPrevInputLength=0;
var g_editorInputList = new Array();
var g_editorInputLength=0;
var g_fileTransfer;
var g_msgFolder;


function GetAllEditorInput() {
		//alert("GetUserInput");
    var msgFolder="MESSAGES";
    if(g_curSelectedCity=="Quebec")
        g_msgFolder = "/MESSAGES/";
    else
    if(g_curSelectedCity=="Montreal")
        g_msgFolder = "/MESSAGES2/";
    else
    if(g_curSelectedCity=="Gatineau")
        g_msgFolder = "/MESSAGES3/";
    else
    if(g_curSelectedCity=="TroisRivieres")
        g_msgFolder = "/MESSAGES4/";
    
        
		var urlExt = g_serverID+"phpservices/GetAllInput.php";
		var dataString = "?path=" + g_dataDirectory + "/NETWORKS/"+g_curNetwork+g_msgFolder; 
		//console.log(urlExt+dataString);
		//DisplayLoader("Un moment svp!");
		$.ajax({
			type: "POST",
			url: urlExt+dataString,
			dataType: "xml",
			async: false,
			cache: false,
            success: function(data) {
				//alert(response);
				var xmlDoc = data;
                
				//var dataTag = xmlDoc.getElementsByTagName("data");

                var dataSet = xmlDoc.getElementsByTagName("UserInput");
				var prevInputList = g_editorInputList;
				var prevInputLength=g_editorInputLength;
				g_editorInputList=[];
				g_editorInputLength=0;
				var maxtime=0;
				//console.log(dataSet.length);
                for (var i = 0; i < dataSet.length; i++) {
                    //Get city attributes
                    var xmlAtt = dataSet[i].attributes;
                    var published = xmlAtt.getNamedItem("published").nodeValue;
                    var filename = xmlAtt.getNamedItem("filename").nodeValue;
                    var userID = xmlAtt.getNamedItem("userID").nodeValue;
                    var userName = xmlAtt.getNamedItem("userName").nodeValue;
                    var userAvatar = xmlAtt.getNamedItem("userAvatar").nodeValue;
                    var roadID = xmlAtt.getNamedItem("roadID").nodeValue;
                    var direction = xmlAtt.getNamedItem("direction").nodeValue;
           
                    var date = xmlAtt.getNamedItem("date").nodeValue;
                    var time = xmlAtt.getNamedItem("time").nodeValue;
                    var lat = xmlAtt.getNamedItem("lat").nodeValue;
                    var lng = xmlAtt.getNamedItem("lng").nodeValue;
                    var type = xmlAtt.getNamedItem("type").nodeValue;
                    var alertType = xmlAtt.getNamedItem("alert").nodeValue;
                    var description = xmlAtt.getNamedItem("description").nodeValue;
                    var audioFile = xmlAtt.getNamedItem("audioFile").nodeValue;
                    var audioMute = xmlAtt.getNamedItem("audioMute").nodeValue;
                    var imageType = xmlAtt.getNamedItem("imageType").nodeValue;
                    var imageURL = xmlAtt.getNamedItem("imageURL").nodeValue;
                    var cameraURL = xmlAtt.getNamedItem("cameraURL").nodeValue;
					if(userName=="")
						userName="Usager";
					//Only get newest data
					var splitval=time.split(":");
					var newtime = parseInt(splitval[0])*3600+parseInt(splitval[1])*60+parseInt(splitval[2]);
					maxtime = Math.max(maxtime,newtime);

					//Add marker to the list
					
					g_editorInputList[g_editorInputLength]=new UserInput(userID,userName,userAvatar,roadID,direction,1000+g_editorInputLength,type, alertType,lat,lng,date,time,description,published,audioFile,audioMute,imageType,imageURL,cameraURL,filename);
					g_editorInputLength++;
				}

				HideLoader();
				//UpdateEditorInput(prevInputList,prevInputLength,g_editorInputList,g_editorInputLength);
				//alert(g_editorInputLength);
				//alert("Add "+g_editorInputLength+ " Prev "+g_prevInputLength);
				//if(g_editorInputLength!=g_prevInputLength){
					g_userInputUpdate=true;
					g_prevInputLength = g_editorInputLength; 
				//}
				
            },
			error:function (xhr, status, error){
				//alert("Erreur :"+xhr.responseText+" ("+status+" - "+error+")");
			}
        });
		//alert(g_userInputUpdate);
		if(g_userInputUpdate==true){
			g_userInputUpdate=false
			return true;
		}
		else
			return false;
}
function PostUserInput(_userInput){
	

	var userID=_userInput.userID;
	var userName=_userInput.userName;
	var userAvatar=_userInput.userAvatar;
	var roadID=_userInput.roadID;
	var direction=_userInput.direction;
	var pinindex=_userInput.index;
	var type=_userInput.type;
	var alertType=_userInput.alertType;
	var lat=_userInput.lat;
	var lng=_userInput.lng;
	var description=_userInput.description;
	var audioFile=_userInput.audioFile;
	var audioMute=_userInput.audioMute;
	var imageType=_userInput.imageType;
	var imageURL=_userInput.imageURL;
	var cameraURL=_userInput.cameraURL;
	var published=_userInput.published;
	//Publish user input to server
	var urlExt = g_serverID+"phpservices/PostInput.php";
	var path = g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder;
	var dataString = '?published='+published+'&userID='+userID+'&userName='+userName+'&userAvatar='+userAvatar+'&roadID='+roadID+'&direction='+direction+'&index='+pinindex+'&type='+type+'&alert='+alertType+'&lat='+lat+'&lng='+lng+'&description='+description+'&audioFile='+audioFile+'&audioMute='+audioMute+'&imageType='+imageType+'&imageURL='+imageURL+'&cameraURL='+cameraURL+'&path='+path;
	console.log(dataString);
	//alert(urlExt+' '+dataString);
	//DisplayLoader("Un moment svp!");
	//alert(urlExt+dataString);
	//alert(urlExt);
	var nbrLoop=0; 
	$.ajax({
		type: "POST",
		url: urlExt+dataString,
        contentType: "charset=utf-8",
		dataType: "text",
		async: true,
		cache: false,
		timeout: 1000,
        success: function(response) {
			//HideLoader();
			console.log('Publish '+response);
			g_disableRefresh=false;
			//if(_foo!=null)
			//	_foo.call();
        },
		error:function (xhr, status){
            console.log(status);
			nbrLoop++;
			if(nbrLoop<=5)
				PostUserInput(_userInput);
			else
				g_disableRefresh=true;
		}
    });
	
}	
function UpdateEditorInput(_prevEditorInputList,_prevEditorInputLength,_newEditorInputList,_newEditorInputLength){
	//Delete old input that does not exist
	var i,j;
	for( i=0;i<_prevEditorInputLength;i++){
			var deleteMarker=true;
			for(j=0;j<_newEditorInputLength;j++){
				if(_prevEditorInputList[i].filename==_newEditorInputList[j].filename){
					deleteMarker=false;
					j=_newEditorInputLength;
				}
			}
			if(deleteMarker==true){
				if(_prevEditorInputList[i].marker!=0 ){
					var marker = _prevEditorInputList[i].marker.get(0);
					marker.setVisible(false);
					marker.setMap(null);
				}
			}
	}
	RefreshMapCanvas();
	//Wait a little bit before adding new to let canvas refresh
	setTimeout(function(){
		//Add new inputs
		for( i=0;i<_newEditorInputLength;i++){
			var prevMarker;
			var addMarker=true;
			for(j=0;j<_prevEditorInputLength;j++){
				if(_newEditorInputList[i].filename==_prevEditorInputList[j].filename){
					addMarker=false;
					prevMarker = _prevEditorInputList[i].marker;
					j=_prevEditorInputLength;
				}
			}
			if(addMarker==true){
				_newEditorInputList[i].marker=AddUserInputPin(_newEditorInputList[i].alertType,i,_newEditorInputList[i].lat,_newEditorInputList[i].lng);

			}
			else{
				_newEditorInputList[i].marker=prevMarker;
			}
		}
		//alert('ClearEditorInput');
		RefreshMapCanvas();
	},250);
	
}
function ClearEditorInput(_editorInputList,_editorInputLength){
		//Delete it on the map
	for(var i=0;i<_editorInputLength;i++){
		if(_editorInputList[i].marker!=0){
			var marker = _editorInputList[i].marker.get(0);
			marker.setMap(null);
		}
	}
	//alert('ClearEditorInput');
	//RefreshMapCanvas();
	
}
function RefreshEditorInput(_editorInputList,_editorInputLength){
		//Delete it on the map
	//	alert(g_editorInputLength);
	for(var i=0;i<_editorInputLength;i++){
		//if(g_editorInputList[i].published=="true")
			_editorInputList[i].marker=AddUserInputPin(_editorInputList[i].alertType,i,_editorInputList[i].lat,_editorInputList[i].lng);
		//else
		//	_editorInputList[i].marker=0;

	}
	//alert('RefreshEditorInput');
	RefreshMapCanvas();
}

function AddUserInputPin(_alertType,_index,_lat,_lng) {

//Create user marker pin
	//alert(_lat+" " +_lng);
	latlng = new google.maps.LatLng(parseFloat(_lat),parseFloat(_lng));
	var markerOption = {
		'id':'userpin',
        'position': latlng,
        'visible': true,
        'zIndex': _index+1000, //parseInt(_index),
        'icon': GetAlertPin(_alertType)
    };
	//alert(_newCamID);
	//console.println(camerasMap[_newCamID].lat+ " "+camerasMap[_newCamID].lon);
	var newMarker = $('#map_canvas').gmap('addMarker', markerOption);
	//alert('Done '+_index);
	//alert(" New"+_index);
	//alert("SelectMarker");
	newMarker.click(function() {
		var index = this.getZIndex()-1000;
		//alert(index);
		//Display alert preview
		ShowAlertPreview(index);
		//Show preview panel
		ShowPage('user');

    });
	
	return newMarker;
}
function GetAlertPin(_alertType){

	var pinIcon=0;
	switch(parseInt(_alertType)){
		case 1:
			pinIcon = "css/images/pinAlertWarning.png"; //pinAlertSlowdown.png";
			break;
		case 2:
			pinIcon = "css/images/pinAlertWarning.png"; //pinAlertCongestion.png";
			break;
		case 3:
			pinIcon = "css/images/pinAlertWarning.png"; //pinAlertAccident.png";
			break;
		case 4:
			pinIcon = "css/images/pinAlertWarning.png"; //circleCamMove.png";
			break;
		case 5:
			pinIcon = "css/images/pinAlertWorkzone.png";
			break;
		default:
			pinIcon = "css/images/pinAlertWarning.png";
			break;
	}
	return pinIcon;
}
function GetAlertCircle(_alertType){

	var pinIcon=0;
	switch(parseInt(_alertType)){
		case 1:
			pinIcon = "css/images/circleWarning.png"; //circleSlowdown.png";
			break;
		case 2:
			pinIcon = "css/images/circleWarning.png"; //circleCongestion.png";
			break;
		case 3:
			pinIcon = "css/images/circleWarning.png"; //circleAccident.png";
			break;
		case 4:
			pinIcon = "css/images/circleWarning.png"; //circleCamMove.png";
			break;
		case 5:
			pinIcon = "css/images/circleWorkzone.png";
			break;
		default:
			pinIcon = "css/images/circleWarning.png";
			break;
	}
	return pinIcon;
}
function ShowAlertPreview(_index){
	
	g_AlertIndex =_index;
	var imgPlayer = document.getElementById('userImagePlayer');

	if(g_editorInputList[_index].imageType=='publicity'){
	//Get publicity if specified
		imgPlayer.src = g_imageURL = GetPublicityImage();
		DownloadPreviewToLocalStorage(g_imageURL);
	}
	else
	if(g_editorInputList[_index].imageType=='user' && g_editorInputList[_index].imageURL!="null"){
		//Get cam image if specified
		imgPlayer.src = g_imageURL = g_serverID+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder+g_editorInputList[_index].imageURL;
		DownloadPreviewToLocalStorage(imgPlayer.src);
		//console.log(g_imageURL);
		var videoFilename = g_editorInputList[_index].imageURL.substr(0,g_editorInputList[_index].imageURL.length-4)+'.mp4';
		g_videoURL = g_serverID+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder+videoFilename;
		//console.log(g_videoURL);
	}
	else
	if(g_editorInputList[_index].imageType=='camera' && g_editorInputList[_index].cameraURL!="null"){
        //Get cam image if specified
		imgPlayer.src = g_imageURL = g_serverID+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder+g_editorInputList[_index].imageURL;
		DownloadPreviewToLocalStorage(imgPlayer.src);
	}
	else
	{
		//imgPlayer.src = g_imageURL = "css/images/logo_alerte511_fond_video.png";
		imgPlayer.src = g_imageURL = GetPublicityImage();
		DownloadPreviewToLocalStorage(g_imageURL);
	}
	
	var roadIndex = parseInt(g_editorInputList[_index].roadID);
	if(roadIndex>=0 && roadIndex<segIndex){
		var roadID = segmentsList[parseInt(g_editorInputList[_index].roadID)].route;
		var direction;
		if(g_editorInputList[_index].direction=="All" || g_editorInputList[_index].direction=="Toute")
			direction = segmentsList[parseInt(g_editorInputList[_index].roadID)].description+", dans les deux directions ";
		else
			direction = segmentsList[parseInt(g_editorInputList[_index].roadID)].description+", direction "+g_editorInputList[_index].direction;
		
		$('#pnlAlertPreviewPage span#route').text(roadID);
		$('#pnlAlertPreviewPage span#description').text(direction);
	}
	else
	{
		//$('#pnlAlertPreviewPage #icon').attr("src", "css/images/circleOrange.png");
		$('#pnlAlertPreviewPage span#route').text("Route non-spécifié");
		$('#pnlAlertPreviewPage span#description').text(" ");

	}
	
	//Set arrows
	if(_index==g_userMaxIndex-1){
		$('#divUserCtrlPrevious').removeClass().addClass('divUserCtrlPreviousOff');
	}
	else{
		$('#divUserCtrlPrevious').removeClass().addClass('divUserCtrlPreviousOn');
	}
	if(_index==0){
		$('#divUserCtrlNext').removeClass().addClass('divUserCtrlNextOff');
	}
	else{
		$('#divUserCtrlNext').removeClass().addClass('divUserCtrlNextOn');
	}
	
	//Set update time
	SetUpdate(g_editorInputList[_index].date,g_editorInputList[_index].time);
	//Set userID and note
    $('#pnlAlertPreviewPage span#userName').text( g_editorInputList[_index].userName+": ");
    $('#pnlAlertPreviewPage span#noteCam').text(g_editorInputList[_index].description);
	$('#pnlAlertPreviewPage #time').text(g_editorInputList[_index].time);
	//Change icon
	var iconURL = GetAlertCircle(g_editorInputList[_index].alertType);
	$('#pnlAlertPreviewPage #icon').attr("src", iconURL);
	
	var avatarURL;
	if(g_editorInputList[_index].userAvatar!="null" && g_editorInputList[_index].userAvatar.length>0 )
		avatarURL = g_serverID+"/"+g_dataDirectory+"/NETWORKS/"+g_curNetwork+"/USERS/"+g_editorInputList[_index].userAvatar;
	else
		avatarURL = "css/images/defaultUserIcon.png";
	$('#pnlAlertPreviewPage #avatar').attr("src", avatarURL);
	
	//play audio
	if(g_editorInputList[_index].audioFile==0 || g_editorInputList[_index].audioFile=='null' ||g_editorInputList[_index].audioMute=='true')
		$('#btnPlayMessage').addClass('ui-disabled');
	else
		$('#btnPlayMessage').removeClass('ui-disabled');
		
	
}
function ShowAlertBulletin(_index){
	
	g_AlertIndex =_index;
	var imgPlayer = document.getElementById('imagePlayer2');

	if(g_editorInputList[_index].imageType=='publicity'){
	//Get publicity if specified
		imgPlayer.src = g_imageURL = GetPublicityImage();
	}
	else
	if(g_editorInputList[_index].imageType=='user' && g_editorInputList[_index].imageURL!="null"){
		//Get cam image if specified
		imgPlayer.src = g_imageURL = g_serverID+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder+g_editorInputList[_index].imageURL;
	}
	else
	if(g_editorInputList[_index].imageType=='camera' && g_editorInputList[_index].cameraURL!="null"){
		//Get cam image if specified
		imgPlayer.src = g_imageURL = g_serverID+g_dataDirectory+"/IMAGES" + g_sInputIndex + "/" + g_editorInputList[_index].cameraURL + ".jpg";
	}
	else
	{
		//imgPlayer.src = g_imageURL = "css/images/logo_alerte511_fond_video.png";
		imgPlayer.src = g_imageURL = GetPublicityImage();
	}
	$('.pnlCameraBulletinInfoBox').css('display','block');

	var roadIndex = parseInt(g_editorInputList[_index].roadID);
	if(roadIndex>=0 && roadIndex<segIndex){
		var roadID = segmentsList[parseInt(g_editorInputList[_index].roadID)].route;
		var direction;
		if(g_editorInputList[_index].direction=="All" || g_editorInputList[_index].direction=="Toute")
			direction = segmentsList[parseInt(g_editorInputList[_index].roadID)].description+", dans les deux directions ";
		else
			direction = segmentsList[parseInt(g_editorInputList[_index].roadID)].description+", direction "+g_editorInputList[_index].direction;
		
		$('#pnlCameraBulletinPage span#route').text(roadID);
		$('#pnlCameraBulletinPage span#description').text(direction);
	}
	else
	{
		$('#pnlCameraBulletinPage span#route').text("Route non-spécifié");
		$('#pnlCameraBulletinPage span#description').text(" ");

	}

	//Set update time
	SetUpdate(g_editorInputList[_index].date,g_editorInputList[_index].time);
	//Set userID and note
    $('#pnlCameraBulletinPage span#userName').text( g_editorInputList[_index].userName+": ");
    $('#pnlCameraBulletinPage span#noteCam').text(g_editorInputList[_index].description);
	$('#pnlCameraBulletinPage #time').text(g_editorInputList[_index].time);
	//Change icon
	var iconURL = GetAlertCircle(g_editorInputList[_index].alertType);
	$('#pnlCameraBulletinPage #icon').attr("src", iconURL);
	
	var avatarURL;
	if(g_editorInputList[_index].userAvatar!="null" && g_editorInputList[_index].userAvatar.length>0 )
		avatarURL = g_serverID+"/"+g_dataDirectory+"/NETWORKS/"+g_curNetwork+"/USERS/"+g_editorInputList[_index].userAvatar;
	else
		avatarURL = "css/images/defaultUserIcon.png";
	$('#pnlCameraBulletinPage #avatar').attr("src", avatarURL);

}
function PublishCameraAlert(){
	//play message end
	RecordingPlayEnd();
	
	//alert(g_PictureLocalFilename);
	
    //Upload avatar
	g_disableRefresh=true;
	var ft = new FileTransfer();
	g_uploadAudioTry=0;
	g_uploadPictureTry=0;
	g_uploadAvatarPictureTry=0;

	//Upload picture
    
	uploadPictureFile(ft,g_PictureLocalFilename,function(){
			uploadUserInput();
	});

}
function PublishAlert(){
	//play message end
	RecordingPlayEnd();
	
	//alert(g_PictureLocalFilename);
	
		//Uplod avatar
	g_disableRefresh=true;
	var ft = new FileTransfer();
	g_uploadAudioTry=0;
	g_uploadPictureTry=0;
	g_uploadAvatarPictureTry=0;

	//Upload picture
	uploadPictureFile(ft,g_PictureLocalFilename,function(){
		//Upload audio file
		uploadAudioFile(ft,g_AudioLocalFilename,function(){
			uploadUserInput();
		});
	});
	
	

	

}
function uploadUserInput(){
	
		
		
		var roadID=0;
		var direction="Toute";
		
		//Get alert  type 
		//var g_alertType=$('#alertInfo').val();
		
		//Get description
		var description = $('#textareaInfo').val();
		//Get date and time
		var date = new Date();
		var strDate = date.getFullYear() + "-" + date.getMonth() + "-" + date.getDate();
		var strTime = date.getHours() + ":" + date.getMinutes() ;


		//Create new user input
		var newInput =  new UserInput(GetUserID(),g_userProfil.username,g_userProfil.avatar,roadID,direction,0,0, g_alertType,g_userLat,g_userLon,strDate,strTime,description,"false",g_AudioRemoteFilename,'false','user',g_PictureRemoteFilename,null,0);
		console.log('PostUserInput');
		//Post user input
		PostUserInput(newInput);
		
	

}

