/*  ======================================================================================================================================================================
Global variables 
====================================================================================================================================================================== */


var g_bRegionalBulletinMode = false;
var g_bLocalBulletinMode=false;
var g_bRegionalBulletinPlaying = false;
var g_bLocalBulletinPlaying=false;
var g_bFirstLoop = true;
var g_updateTimerHandle=0;
var g_audioList = new Array();
var g_videoList = new Array();
var g_videoTiming = new Array();
var g_bulletinList = new Array();

var g_updatePeriod=0;
var g_allOnlyHotspots = true;
var g_navOnlyHotspots = true;
var g_allOnlyWhenAlerts=false;
var g_navOnlyWhenAlerts=false;

function Bulletin(video,audio,statusIcon,roadName,typeIcon,message) {
    this.video = video;
    this.audio = audio;
    this.statusIcon = statusIcon;
    this.roadName = roadName;
    this.message = message;

}

function InitSelectBox() {
    var select = document.getElementById("ctrlCity");
    select.options.length = 0;
    for (var i = 0; i < cityIndex; i++) {
        //alert(citiesList[i].cityName);
        select.options[i] = new Option(citiesList[i].cityName, citiesList[i].id);
        if (citiesList[i].enabled && g_curSelectedCity.length == 0) {
            g_curSelectedCity = citiesList[i].id;
            //alert(g_curSelectedCity);
        }
        
    }
    $('#ctrlCity').selectmenu('refresh', true);

}
/////////////////////////////////////////////////////////////////////
//Select city 
function selectCity(_city) {

    //alert(_city);
    if (citiesMap[_city].enabled==false){
        PopAlert("Bientôt disponible");
             
    }
    else
        g_curSelectedCity = _city;

    $('#ctrlCity option[value=' + g_curSelectedCity + ']').attr('selected', 'selected');

}


function StartStopRegionalBulletin(){

		//console.println(g_bRegionalBulletinMode+" "+g_bLocalBulletinPlaying);
		if (g_bRegionalBulletinMode == false) {

			g_bRegionalBulletinMode=true;
			//Pause audio stream
			//PauseAudioStream(true);

			//Start playing
			if(g_updatePeriod>0)
				UpdateBulletin();
			else{
				PlayRegionalBulletin();
			}			
		}
		else {
		//Stop Timer
			//alert('stopBulletin');
			if(g_updateTimerHandle!=0)
				clearTimeout(g_updateTimerHandle);				
			g_updateTimerHandle=0;
			
			StopPlayUserMessages();
			
			//stopAudio();
			//StopAudioPlayer();

			g_bRegionalBulletinMode=false;
			//Set Menu Bar
			ResetMenuBar();
			//Reset Map position
			//ResetMapPosition();
			//Hide Loader
			HideLoader();
		}
		

 	
}
function UpdateBulletin(){
	//Generate regional bulletin
	PlayRegionalBulletin();
	
	g_updateTimerHandle = setTimeout(function(){
			PauseAudioStream(true);
			UpdateBulletin();
		},g_updatePeriod*60000);
	
}
function RestartUpdateBulletin(){
	if(g_bRegionalBulletinMode==true){
		if(g_updatePeriod==0)
			StartStopRegionalBulletin();
		else{

			if(g_updateTimerHandle!=0)
				clearTimeout(g_updateTimerHandle);				
			g_updateTimerHandle=0;
				g_updateTimerHandle = setTimeout(function(){
						PauseAudioStream(true);
						UpdateBulletin();
					},g_updatePeriod*60000);
		}
	}
	
}

function PlayWelcomeBulletin(){
	//Put welcome message
	AddWelcomeMsg();
	PlayAudioVideoList(g_audioList,g_videoList,false);

}

function PlayRegionalBulletin(){

	
		
	g_bRegionalBulletinPlaying=true;
	g_audioList = [];
	g_videoList = [];
		
   //Play welcome message first time.
    // Also we need to start playing otherwise the audio player will not start on mobile (disable by default)
	//if(g_bFirstLoop==true){
	//Put welcome message
	//	AddWelcomeMsg();
	//}
	DisplayWelcomeImage();
	ShowPage('bulletin');
	//PlayAllUserMessage(null);
	var srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/Other/bell.mp3" ; 
	PlayAudio(srcFilename,function(){
		
		var nbrMessages = GetNbrMessages();
		if(nbrMessages==0 ){
			srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/Other/noProblem.mp3" 
			PlayAudio(srcFilename,function(){
				srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/Other/ending.mp3" 
				PlayAudio(srcFilename,function(){ShowPrevPage();},function(){ShowPrevPage();},null);
			},function(){ShowPrevPage();},null);
		}
		else
		{
			PlayAllUserMessage(function(){ShowPrevPage();});
		}
		
		//Generate alert report
		/*var nbrWarnings=CheckIfWarnings("regional");
		var nbrMessages = GetNbrMessages();
		
		if(nbrMessages==0 && nbrWarnings==0){
			AddNoProblemMsg();
			AddEndingMsg();
		}
		else
		if(nbrWarnings==0 && nbrMessages>0){
			PlayAllUserMessage(function(){ShowPrevPage();});
		}
		else
		if(nbrWarnings>0 || g_allOnlyHotspots==false){
			g_audioList.push( "Other/warning");
			g_videoList.push("none");
			GenerateTrafficReport("regional");
			//Play report
			if((g_allOnlyWhenAlerts==true && nbrWarnings>0) || g_allOnlyWhenAlerts==false){
				PlayAudioVideoList(g_audioList,g_videoList,true);
			}
		}*/

	
		
		g_bFirstLoop=false;
	},function(){ShowPrevPage();},null);	

}

function PlayLocalBulletinIntro(){

	//Return if not in navigation mode or playing bulletin
	//if(g_bLocalBulletinMode==false)
	//	return false;
		
	if(g_bLocalBulletinPlaying==true || g_bRegionalBulletinPlaying==true)
		return false;
	//console.println("PlayLocalBulletin");

	//DisplayLoader("Un moment svp!");
	
	g_bLocalBulletinPlaying=true;
	g_audioList = [];
	g_videoList = [];	

	//Put welcome message
	//g_audioList.push("Other/bienvenu");
	//g_videoList.push("none");
	//Put intro message
	g_audioList.push("Other/introLocal");
	g_videoList.push("none");	
	//Put ending message
	//AddEndingMsg();	
	
	//Play report
	PlayAudioVideoList(g_audioList,g_videoList,false);
	g_bFirstLoop=false;
 	return true;

}

function PlayLocalBulletin(_segID){

	//Return if not in navigation mode or playing bulletin
	//if(g_bLocalBulletinMode==false)
	//	return false;
	//alert(g_bLocalBulletinPlaying);	
	//alert("PlayLocalBulletin");
	if(g_bLocalBulletinPlaying==true || g_bRegionalBulletinPlaying==true)
		return false;

	//DisplayLoader("Un moment svp!");
	
	g_bLocalBulletinPlaying=true;
	g_audioList = [];
	g_videoList = [];	

	
	//Generate intro
	//g_audioList.push( "Other/intronavigation");
	//g_videoList.push(g_closestCamID);

	//Generate warning bulletin
	var nbrWarnings=CheckIfWarnings("local");
	//alert(nbrWarnings);
	if(nbrWarnings>0 || g_navOnlyHotspots==false){
		//g_audioList.push( "Other/bell");
		//g_videoList.push(g_closestCamID);
		g_audioList.push( "Other/warning");
		g_videoList.push(g_closestCamID);
		GenerateSegmentReport(g_currentSegID);
		GenerateTrafficReport("local");
		//AddEndingMsg();
	}
	else{
		//Play location
		var msg1 = segmentsMap[_segID].msg1;
		g_audioList.push(msg1);
		g_videoList.push(g_closestCamID);
		g_audioList.push( "Other/noProblem");
		g_videoList.push(g_closestCamID);
	}
		
	//Put ending message

	//Play report

	if((g_navOnlyWhenAlerts==true && nbrWarnings>0) || g_navOnlyWhenAlerts==false)
		PlayAudioVideoList(g_audioList,g_videoList,true);
	g_bFirstLoop=false;

 	return true;

}
/*  ======================================================================================================================================================================
Load each camera alert XML files for the current city
====================================================================================================================================================================== */

function AddWelcomeMsg(){
 
	//Put welcome message
	g_audioList.push("Other/bienvenu");
	g_videoList.push("none");
	//Put intro message
	//g_audioList.push("introWarning");
	//g_videoList.push("none");	
	//Put ending message
	//AddEndingMsg();
}
function AddEndingMsg(){
 
	g_audioList.push("Other/ending");
	g_videoList.push("none");
}

function AddNoProblemMsg(){

	g_audioList.push( "Other/noProblem");
	g_videoList.push("none");
}

function CheckIfWarnings(_reportType) {
		
    var warnings = 0;
    if(_reportType=="regional"){
		for (var i = 0; i < alertSegIndex; i++) {
			if (segAlertsList[i].classID > 1 && segAlertsList[i].classID < 4) {
				warnings++;
			}
		}
	}
	else
	if(_reportType=="local"){

		for (var i = 0; i < alertSegIndex; i++) {
			if (segAlertsList[i].report==true && segAlertsList[i].classID > 1 && segAlertsList[i].classID < 4) {
				warnings++;
			}
		}
	}
	//alert(" Warnings " + warnings);
    return(warnings);
}
      
function GenerateTrafficReport(_reportType) {

   //alert("GenerateAlertReport ");

    var noProblem = true;
    
    for (var i = 0; i < alertSegIndex; i++) {
 
            //Display Alert
              if (segmentsMap[segAlertsList[i].segID] != null) {
				if(_reportType=="regional" || 
				  (_reportType=="local" && segAlertsList[i].segID!=g_currentSegID && segAlertsList[i].report==true )  )
				{
					GenerateSegmentReport(segAlertsList[i].segID);
				}
            }
    }
	
  
}
function GenerateSegmentReport(_segID) {
	var msg1, msg2;
	
	if ((g_allOnlyHotspots == false || g_navOnlyHotspots == false) || 
		((g_allOnlyHotspots == true || g_navOnlyHotspots == true) && segAlertsMap[_segID].classID > 1 && segAlertsMap[_segID].classID < 4)) {
		msg1 = segmentsMap[_segID].msg1;
		//alert(_segID);
		if (msg1 != null) {
			//Report segment ID
		//	g_audioList.push(msg1);
			//g_videoList.push(segAlertsMap[_segID].camID);
			//alert(segAlertsList[i].camID);
			// g_audioList.push(folder + msg2);
			var status;
			var msg2;
			//report traffic status

			if (segAlertsMap[_segID].classID == 1)
				status = "fluide";
			else
				if (segAlertsMap[_segID].classID == 2)
					status = "Slow";
				else
					if (segAlertsMap[_segID].classID == 3)
						status = "Jam";

			//report direction
			//alert(segAlertsList[i].segID + " " + segAlertsList[i].dirrection);
			if (status == "Slow" || status == "Jam") {
				noProblem = false;

				if (segAlertsMap[_segID].direction == "Nord" || segAlertsMap[_segID].direction == "nord")
					msg2 = status + "North";
				else
					if (segAlertsMap[_segID].direction == "Sud" || segAlertsMap[_segID].direction == "sud")
						msg2 = status + "South";
					else
						if (segAlertsMap[_segID].direction == "Est" || segAlertsMap[_segID].direction == "est")
							msg2 = status + "East";
						else
							if (segAlertsMap[_segID].direction == "Ouest" || segAlertsMap[_segID].direction == "ouest")
								msg2 = status + "West";
							else
								if (segAlertsMap[_segID].direction == "NordSud" ||
									segAlertsMap[_segID].direction == "SudNord" ||
									segAlertsMap[_segID].direction == "EstOuest" ||
									segAlertsMap[_segID].direction == "OuestEst" ||
									segAlertsMap[_segID].direction == "All")
									msg2 = status + "Both";
			}
			else {
				if (segAlertsMap[_segID].classID == 1)
					msg2 = "fluide";
				else
					msg2 = "nonDisponible";
			}
			msg2 =  msg2+"/"+_segID;
			//alert(msg2);
			g_audioList.push( msg2);
			g_videoList.push(segAlertsMap[_segID].camID);
			//console.println(msg1 + " "+msg2);
		}
	}

}
function GenerateSegmentID(_segID,_direction) {


	var msg1 = segmentsMap[_segID].msg1;
	g_audioList.push(msg1);
	g_videoList.push("none");

	/*if (_direction == "Nord" || _direction == "nord")
		msg2 = status + "Nord";
	else
		if (_direction == "Sud" || _direction == "sud")
			msg2 = status + "Sud";
		else
			if (_direction == "Est" || _direction == "est")
				msg2 = status + "Est";
			else
				if (_direction == "Ouest" || _direction == "ouest")
					msg2 = status + "Ouest";
	g_audioList.push( msg2);
	g_videoList.push("none");
	*/
	
}
function BindBulletinEvents(){

	$('#btnPlayRegional').on("click", function() {
		//Start bulletin
		g_shownPage='bulletin';
		StartStopRegionalBulletin();
	});
	$('#btnCancelBulletin').on("click", function() {
	//alert(g_updatePeriod);
        //Stop audio bulletin;
		//if(g_updatePeriod==0 )
		StartStopRegionalBulletin();
		//else
		//	StopAudioPlayer();
		//Show main page
		ShowPrevPage();
		//Restart audio stream
		//PauseAudioStream(false);

    });	
	$('#select-period').bind("change", function() {
		var value = $(this).val();
		if(value=="period-0")
			g_updatePeriod=0;
		else
		if(value=="period-0")
			g_updatePeriod=0;
		else
		if(value=="period-1")
			g_updatePeriod=1;
		else
		if(value=="period-5")
			g_updatePeriod=5;
		else
		if(value=="period-10")
			g_updatePeriod=10;
		else
		if(value=="period-15")
			g_updatePeriod=15;
		else
		if(value=="period-20")
			g_updatePeriod=20;
		else
		if(value=="period-25")
			g_updatePeriod=25;
		else
		if(value=="period-30")
			g_updatePeriod=30;
			
		//Restart update if activated
		RestartUpdateBulletin();
			
    });	
	$('#radio-everytime').bind("click", function() {
		g_allOnlyWhenAlerts=false;
    });	
	$('#radio-onalerts').bind("click", function() {
		g_allOnlyWhenAlerts=true;
    });	
	
}

