//Local storage
function setUserCity(_defaultCity){

    g_curSelectedCity=_defaultCity;
    SetLocalItem('userCity',_defaultCity);
    
}
function getUserCity(){

    var selectedCity=GetLocalItem('userCity');
     if(selectedCity!=null)
     {
        g_curSelectedCity=selectedCity;
        
     }
    return g_curSelectedCity;

}

function GetUserFavorite()
{

	//Check if local storage is avialble
	if(typeof(window.localStorage) == 'undefined'){
		PopAlert("Local Storage Not available");
		return
	}
	//ClearLocalStorage();
	//Get camera status
	for (camera in camerasList) {
		 
		var isFavorite = GetLocalItem (camerasList[camera].id);
		//alert(camerasList[camera].id+" "+isFavorite);
		if(isFavorite!=null){
			if(isFavorite=='true'){
				//alert(camerasList[camera].id+" "+isFavorite);
				camerasList[camera].isFavorite=true;
			}
			else
				camerasList[camera].isFavorite=false;
		}
		else
			camerasList[camera].isFavorite=false;
			
		SetLocalItem(camerasList[camera].id,camerasList[camera].isFavorite);
	}
	
}
function GetUserSettings()
{
	//Check if local storage is avialble
	if(typeof(window.localStorage) == 'undefined'){
		PopAlert("Local Storage Not available");
		return
	}
	//Get udpate period
/*	var update_period = GetLocalItem('update_period');
	if(update_period!=null)
		g_updatePeriod = parseInt(update_period);
		
	//alert(update_period);
	if(g_updatePeriod==0)
		$("#select-period option[value='period-0']").attr('selected', 'selected');
	else
	if(g_updatePeriod==5)
		$("#select-period option[value='period-5']").attr('selected', 'selected');
	else
	if(g_updatePeriod==10)
		$("#select-period option[value='period-10']").attr('selected', 'selected');
	else
	if(g_updatePeriod==15)
		$("#select-period option[value='period-15']").attr('selected', 'selected');
	else
	if(g_updatePeriod==20)
		$("#select-period option[value='period-20']").attr('selected', 'selected');
	else
	if(g_updatePeriod==25)
		$("#select-period option[value='period-25']").attr('selected', 'selected');
	else
	if(g_updatePeriod==30)
		$("#select-period option[value='period-30']").attr('selected', 'selected');
	
*/
//Get user name
/*	var username = GetLocalItem('username');
	if(username!=null && username!='null'){
		g_userName = username;
		//alert(g_userName);
		$('#username').val(g_userName);
	}
	var useravatar = GetLocalItem('useravatar');
	if(useravatar!=null && useravatar!='null'){
		g_avatar=useravatar;
		//alert(g_avatar);
		changeAvatar(g_avatar);
		//checkIfAvatarFileExists(g_avatar);
	}
	*/

	//Get only on alert
/*	var play_only_on_alert = GetLocalItem('play_only_on_alert');
	if(play_only_on_alert!=null)
		if(play_only_on_alert=='true')
			g_navOnlyWhenAlerts = true;
		else
			g_navOnlyWhenAlerts = false;
	$("#radio-onalerts").attr('checked', g_navOnlyWhenAlerts);
	
	//Get only on alert
	var noGPS = GetLocalItem('nogps');
	if(noGPS!=null)
		if(noGPS=='true')
			g_noGPS = true;
		else
			g_noGPS = false;
	$("#radio-nogps").attr('checked', g_noGPS);
*/	

}
function SetUserSettings()
{
	//Check if local storage is avialble
	if(typeof(window.localStorage) == 'undefined'){
		PopAlert("Local Storage Not available");
		return
	}
	//Set user name
	//SetLocalItem('username',g_userName);

	//Set user avater
	//alert('Save '+g_avatar);
	//SetLocalItem('useravatar',g_avatar);
	
	//Set play on alert only
	//Set play on alert only
	//SetLocalItem('play_only_on_alert',g_navOnlyWhenAlerts);
	
	//Set no GPS flag
	//SetLocalItem('nogps',g_noGPS);
	
	
	
}
function ResetAlert(){
	var date = new Date();
	var month = date.getMonth();
	SetLocalItem('nbralert',0);
	SetLocalItem('alertdate',month);

}
function CheckNbrAlert(){
	var date = new Date();
	var month = date.getMonth();
	var prevmonth = GetLocalItem('alertdate');
	var nbralert = parseInt(GetLocalItem('nbralert'));
	var nbrmaxalert=parseInt(g_userProfil.nbrmaxalerts);
	//alert(month+' '+prevmonth+' '+nbralert);
	
	//Reset counter
	if(prevmonth==null || month!=prevmonth){
		SetLocalItem('nbralert',1);
		SetLocalItem('alertdate',month);
		return true;
	}
	else //Max number of alert per month
	if(nbralert!=null && nbralert>nbrmaxalert){
		return false;
	}
	else{
		nbralert++;
		SetLocalItem('nbralert',nbralert);
		SetLocalItem('alertdate',month);
		return true;
	}

}
function SetUserID(userID){
	SetLocalItem('userID',userID);
}
function GetUserID(){
	var userID = GetLocalItem('userID');
	if(userID!=null && userID!='null'){
		return userID;
	}
	else
		return null;
}
function GetLocalItem(_key)
{
//Check if local storage is avialble
	if(typeof(window.localStorage) != 'undefined')
		return(window.localStorage.getItem (_key));
	else
		PopAlert("Local Storage Not available");
		
	
}
function SetLocalItem(_key,_value)
{
	//alert("SetLocalItem "+_key+" "+_value);

//Check if local storage is avialble
	if(typeof(window.localStorage) != 'undefined')
		window.localStorage.setItem (_key,_value);
	else
		PopAlert("Local Storage Not available");
		
	
}
function ClearUserFavorite()
{
	//alert("ClearUserFavorite");
	if(typeof(window.localStorage) != 'undefined'){
		for (camera in camerasList) {
		 
			SetLocalItem(camerasList[camera].id,false);
			camerasList[camera].isFavorite=false;
		}
	}
	else
		PopAlert("Local Storage Not available");
	

}
function ClearUserSettings()
{
	//Check if local storage is avialble
	if(typeof(window.localStorage) == 'undefined'){
		PopAlert("Local Storage Not available");
		return
	}
	//Set user name
	//g_userName='user';
	//SetLocalItem('username',g_userName);

	//Set user avater
	//g_avatar=null;
	//SetLocalItem('useravatar',g_avatar);
	
	//Set play on alert only
	//g_navOnlyWhenAlerts=false;
	//SetLocalItem('play_only_on_alert',g_navOnlyWhenAlerts);
	
	//Set no GPS flag
	//g_noGPS=false;
	//SetLocalItem('nogps',g_noGPS);
	
	//Clear camera favorites
	for (camera in camerasList) {
	 
		SetLocalItem(camerasList[camera].id,false);
		camerasList[camera].isFavorite=false;
	}
	

}