/*  ======================================================================================================================================================================
Global variables 
====================================================================================================================================================================== */


var g_failedInitTimer = 0;
var selectedMenuItem = "bulletin";
var g_sliderDiv=0;
var g_infoScroll=0;
var g_listScroll=0;
var g_displayMode='map';
var g_shownPage='map';
var g_prevPage='map';
var g_Version='phonegap';
var g_refreshRate=10000;
var g_disableRefresh=false;
var g_Scroll1=0;
var g_Scroll2=0;
var g_adMob=true;
var g_adMobInit=false;
var g_iNbrClick=0;


function initializeAlerte511(_success) {

   	console.log('initializeAlerte511');
	console.log(GetOSType());
	//Warning timout
    g_failedInitTimer = setTimeout(function(){
		$(".divMainLoader").css("display","none");
		PopAlert("Erreur de communication Internet. Essayez de nouveau.");
		navigator.app.exitApp();
	},30000);

   
	//Init all
	initAll(_success);


}
function GetOSType()
{
    if(/(android)/i.test(navigator.userAgent) )
        return 'android';
    else
        return 'ios';
   
}

function ResizeAll(){

   // var bannerHeight = $("#header").height();
    var footerHeight = $("#footer").height();
    
	//Offset header for ios7
    var headerOffset=0;
	//if(GetOSType()=='ios'){
	//	headerOffset=bannerHeight;
	//}

    var winWidth,winHeight;
    if($(window).height()==0){
        winHeight = window.screen.height;
        winWidth =  Math.max(320,window.screen.width-1);
    }
    else{
        winHeight =$(window).height(); 
        winWidth =  Math.max(320,$(window).width()-1);
    }
    
    var bannerWidth=320;
    var bannerHeight = 50;
    if(winHeight>720)
    {
        bannerWidth=576;
        bannerHeight=90;
    }
        
   // alert(winWidth+' '+bannerHeight);
	var contentHeight = winHeight-bannerHeight-footerHeight-2-headerOffset;
	var mapHeight = contentHeight-20;
	var previewHeight = winHeight- bannerHeight-20;	
 	var dspWidth = Math.min(352,winWidth-20);
    var dspHeight = Math.min(240,parseInt((dspWidth)*240/352));
    
	//Set overall size
	//Adjust content size
    
	$("#bodyWrapper").css('width',winWidth + 'px');
	$("#bodyWrapper").css('height',winHeight + 'px');

	$("#mainPage").css('width',winWidth + 'px');
	$("#mainPage").css('height',winHeight + 'px');
    
	$("#pnlMainPage").css('width',winWidth + 'px');
	$("#pnlMainPage").css('height',winHeight + 'px');
    
	$("#pnlInfoPage").css('width',winWidth + 'px');
	$("#pnlInfoPage").css('height',winHeight- bannerHeight + 'px');

    $("#header").css('height',bannerHeight + 'px');
    $("#banner").css('height',bannerHeight + 'px');

    $("#banner img").css('width',bannerWidth + 'px');
    $("#banner img").css('height',bannerHeight + 'px');
    var leftMargin = parseInt((winWidth-bannerWidth)/2);
    $("#banner img").css('margin-left',leftMargin+ 'px');
    
    $("#banner").css('display','block');
    $(".selectMenu").css('top',bannerHeight + 'px');

    $("#content").css('padding-top',bannerHeight-50+"px");
 	$("#content").css('width',winWidth + 'px');
	$("#content").css('height',contentHeight + 'px');
	$("#contentNoFooter").css('width',winWidth + 'px');
	$("#contentNoFooter").css('height',contentHeight  - bannerHeight + 'px');
	
	//Map sub page
	$("#divMapWrapper").css('width',winWidth+ 'px');
	$("#divMapWrapper").css('height',contentHeight-15+ 'px');
	$("#divMap").css('width',winWidth + 'px');
	$("#divMap").css('height',mapHeight + 'px');
	$("#map_canvas").css('width',winWidth + 'px');
	$("#map_canvas").css('height',mapHeight + 'px');

	//List sub-page
	$("#divListWrapper").css('width',winWidth+ 'px');
	$("#divListWrapper").css('height',contentHeight-21 + 'px');

	//Camera preview 
	$("#pnlCameraPreviewPage").css('width',dspWidth + 'px');
	$("#pnlCameraPreviewPage").css('height',contentHeight-21+ 'px');
	$(".previewDescription").css('width',dspWidth-120 + 'px');

	//Alert preview
	$("#pnlAlertPreviewPage").css('width',dspWidth + 'px');
	$("#pnlAlertPreviewPage").css('height',contentHeight-21+ 'px');
	
	//Bulletin preview
	$("#pnlCameraBulletinPage").css('width',winWidth + 'px');
	$("#pnlCameraBulletinPage").css('height',contentHeight-21+ 'px');
	
	//Info wrapper
	$("#scroller1").css('width',winWidth-5 + 'px');
	//$("#scroller2").css('width',winWidth-20 + 'px');
	$("#scroller3").css('width',winWidth-20 + 'px');
	$("#wrapperScroll3").css('height',contentHeight+footerHeight-bannerHeight + 'px');
	//$("#wrapperScroll2").css('height',contentHeight+footerHeight + 'px');
	$("#wrapperScroll1").css('top',bannerHeight-30 + 'px');
	    


	//Adjust preview images and video canvas

	//alert(dspWidth+" "+dspHeight);
	//$(".pnlPreviewWrapper").css('height',dspHeight);

    //Put warning at the bottom of image
	$("#divCtrlFavoriteAndShare").css('width',dspWidth);
	$("#divCameraShare").css('margin-left',dspWidth/2-110);
	
	$("#divPlayAudioAndShare").css('width',dspWidth);
	$("#divCtrlPlayAudio").css('width',dspWidth-55);
	
	$("#divCancelBulletin").css('width',dspWidth);
	$("#divPlayMessage").css('width',dspWidth);
	
	$(".divWarningVideo").css('width',dspWidth);
	$(".divWarningVideo").css('margin-top',dspHeight-14);
	
	$(".pnlCameraPreviewImage").css('width',dspWidth);
	$(".pnlCameraPreviewImage").css('height',dspHeight);
	$("#divImagePlayer").css('width',dspWidth);
	$("#divImagePlayer").css('height',dspHeight);
	$("#divVideoPlayer").css('width',dspWidth);
	$("#divVideoPlayer").css('height',dspHeight);
	$("#divUserVideoPlayer").css('width',dspWidth);
	$("#divUserVideoPlayer").css('height',dspHeight);
	
	$("#divCtrlLayer").css('width',dspWidth);
	$("#divCtrlLayer").css('height',dspHeight);
	
	//Ctrl layer on user image
	$("#divUserCtrlLayer").css('width',dspWidth);
	$("#divUserCtrlLayer").css('height',dspHeight);
	$("#divUserCtrlPrevious").css('width',dspWidth);
	$("#divUserCtrlPrevious").css('height',dspHeight/4);
	$("#divUserCtrlMid").css('width',dspWidth);
	$("#divUserCtrlMid").css('height',dspHeight/2);
	$("#divUserCtrlNext").css('width',dspWidth);
	$("#divUserCtrlNext").css('height',dspHeight/4);
	
	$("#divUserImage").css('width',dspWidth);
	$("#divUserImage").css('height',dspHeight);
	$("#userImagePlayer").css('width',dspWidth);
	$("#userImagePlayer").css('height',dspHeight);

	$("#videoPlayer").css('width',dspWidth);
	$("#videoPlayer").css('height',dspHeight);
	$("#imagePlayer").css('width',dspWidth);
	$("#imagePlayer").css('height',dspHeight);
	$("#videoPlayer2").css('width',dspWidth);
	$("#videoPlayer2").css('height',dspHeight);
	$("#imagePlayer2").css('width',dspWidth);
	$("#imagePlayer2").css('height',dspHeight);
	
	$("#pnlCameraSettingImage").css('height',dspHeight+5);
	
	$("#imagePlayer3").css('width',dspWidth);
	$("#imagePlayer3").css('height',dspHeight);
	$("#divAlertPlay").css('width',dspWidth);
	$("#divAlertInfoBox").css('width',dspWidth);
	$("#alertDescription").css('width',dspWidth-70);
	$("#alertDescription #textareaInfo").css('width',dspWidth-70);
	$("#alertDescription #textareaInfo").css('max-width',dspWidth-70);
	//$("#city-value .ui-btn").css('width','100%');
	
	//Offset header for ios7
	//if(GetOSType()=='ios'){
   //    $("#header").css('padding-top',headerOffset+"px");
   //    $("#content").css('padding-top',headerOffset+"px");
	//}

   console.log(winWidth+'x'+winHeight);

}


function UpdateAll(_checkUpdate)
{
        console.log("UpdateMap");
        //alert("UpdateAll");
        DisplayLoader("Un moment svp!");
        XMLReader.LoadRefresh(_checkUpdate,function(){
            HideLoader();
            ResetMenuBar();
            g_iNbrClick=0;
            //Set update time
            SetUpdate(g_sUpdateDate,g_sUpdateTime);
            //Refresh map
            RefreshMap(false);
            //Update list
            if(GetAllEditorInput()==true ){
                //Refresh list
                RefreshList(false);
                //Update preview
                if(g_currentCamID!=0)
                    ShowImagePreview(g_currentCamID);
                
                

            }
        },function(){
            ResetMenuBar();
            HideLoader();
            //g_iNbrClick++;
           // if(g_iNbrClick>2){
            //    PopAlert("Mise à jour pas encore disponible sur le serveur d'Alerte-511. Essayez plus tard."); 
             //   g_iNbrClick=0;
            //}
        });
        
}

function initAll(_success) {

    
//WEBAPP
///	if(g_Version=='webapp'){
//		g_Version='webapp';
//		g_serverID="root/";
//	}
//	else{
		g_Version='phonegap';
		g_serverID="http://www.alerte511.com/";
//	}
//WEBAPP
    // Load city option
    XMLReader = new XMLDataRequest();
    XMLReader.LoadAll(g_curSelectedCity,
            function() {
                if (g_failedInitTimer != 0)
                    clearTimeout(g_failedInitTimer);

                
 				//Init user settings
				GetUserProfil(GetUserID(),null,null);

 				console.log('InitVideoPlayer ');
               //Init video player
                InitVideoPlayer();
                //Init audio player
				//console.log('InitAudioPlayer ');
				//InitAudioPlayer();

				//Create segment list
				//CreateSegmentList();
				//Set update time
				//SetUpdate(g_sUpdateDate,g_sUpdateTime);
 				//Hide first loader
				$(".divMainLoader").css("display","none");
				
				//alert('RefreshMap ');
				//Create map
                RefreshMap(true);
				
				//Init admob
   				//alert('initAdMob ');
                initAdMob(); 
               //Hide splash screen
                if(_success!=null) _success.call();
              


            });


	
}

function initAdMob(){
    if(g_adMob==true && g_adMobInit==false) {
    
       console.log('initAdMob');
       var ad_units = {
		ios : {
			banner: 'ca-app-pub-0491628987407364/4130028310',
			interstitial: 'ca-app-pub-0491628987407364/5606761518'
		},
		android : {
			banner: 'ca-app-pub-0491628987407364/8560227918',
			interstitial: 'ca-app-pub-0491628987407364/1036961116'
		}
       };
        var admobid = ( /(android)/i.test(navigator.userAgent) ) ? ad_units.android : ad_units.ios;
        
        var defaultOptions = {
            publisherId: admobid.banner,
            position: AdMob.AD_POSITION.TOP_CENTER,
            overlap: true, 
            isTesting: false // set to true, to receiving test ad for testing purpose
         };
        AdMob.setOptions( defaultOptions );
        AdMob.createBanner(admobid.banner, 
            function(){
                        AdMob.showBanner(AdMob.AD_POSITION.TOP_CENTER);
                       console.log("AdMob Success");
                     }, 
            function(e){console.log(JSON.stringify(e));});
         
        
        //alert('Done');
         g_adMobInit=true;
    }
          
}


function ShowAd(){

    if(g_adMobInit==true){
        AdMob.showBanner(AdMob.AD_POSITION.TOP_CENTER); 
       // alert("ShowAd");
    }

}
function HideAd(){

   if(g_adMobInit==true) {
       AdMob.hideBanner(); 
      // alert("HideAd");
   }
}

function ShowPage(_type){

	$.mobile.changePage( "#mainPage", { transition: "none"} );
	g_shownPage=_type;
    ShowAd(); 
    
	if(_type=='map'){
		
		DisplayFooter(true);
		$('#divMapWrapper').css('display','block');
		$('#divListWrapper').css('display','none');
		$('#pnlCameraPreviewPage').css('display','none');
		$('#pnlAlertPreviewPage').css('display','none');
		$('#pnlCameraBulletinPage').css('display','none');
		$('#pnlReportPage').css('display','none');
		$('#btnMainBackPrev').css('display','none');
		//g_shownPage=_type;
		g_prevPage='map';
		//Update map
        ResetMapPosition();
        RefreshMap(false);
		//RefreshMapCanvas();

		//Set update time
        ShowUpdate();
		SetUpdate(g_sUpdateDate,g_sUpdateTime);
	}
	else
	if(_type=='list'){
		DisplayFooter(true);
		$('#divMapWrapper').css('display','none');
		$('#divListWrapper').css('display','block');
		$('#pnlCameraPreviewPage').css('display','none');
		$('#pnlAlertPreviewPage').css('display','none');
		$('#pnlCameraBulletinPage').css('display','none');
		$('#pnlReportPage').css('display','none');
		$('#btnMainBackPrev').css('display','none');
		//g_shownPage=_type;
		g_prevPage='list';
        
        //Refressh list 
        RefreshList();
		//Set update time
        ShowUpdate();
		SetUpdate(g_sUpdateDate,g_sUpdateTime);
	}	
	else
	if(_type=='camera'){
     
        SetVideoPlayer("#videoPlayer");
        DisplayFooter(true);
		$('#divMapWrapper').css('display','none');
		$('#divListWrapper').css('display','none');
		$('#pnlCameraPreviewPage').css('display','block');
		$('#pnlAlertPreviewPage').css('display','none');
		$('#pnlCameraBulletinPage').css('display','none');
		$('#btnMainBackPrev').css('display','block');
        HideUpdate();

	}
	else
	if(_type=='user'){
        SetVideoPlayer("#videoPlayer2");
		DisplayFooter(true);
 
		$('#divMapWrapper').css('display','none');
		$('#divListWrapper').css('display','none');
		$('#pnlCameraPreviewPage').css('display','none');
		$('#pnlAlertPreviewPage').css('display','block');
		$('#pnlCameraBulletinPage').css('display','none');
		$('#pnlReportPage').css('display','none');
		$('#btnMainBackPrev').css('display','block');
	}
	else
	if(_type=='bulletin'){
		$('#divMapWrapper').css('display','none');
		$('#divListWrapper').css('display','none');
		$('#pnlCameraPreviewPage').css('display','none');
		$('#pnlAlertPreviewPage').css('display','none');
		$('#pnlCameraBulletinPage').css('display','block');
		$('#pnlReportPage').css('display','none');
		$('#btnMainBackPrev').css('display','none');
		//Hide footer
		DisplayFooter(false);
		//Set update time
		SetUpdate(g_sUpdateDate,g_sUpdateTime);	
	}
	
	setTimeout(function(){ResetMenuBar();},250);	
}
function DisplayFooter(_display){
	if(_display==true){
		$('#footer').css('display','block');
        ResetMenuBar();
    }
	else
		$('#footer').css('display','none');
}
function ShowPrevPage(){
	//$.mobile.changePage( "#mainPage", { transition: "none"} );

	ShowPage(g_prevPage);
	
}

function ShowRecordingPage(){

    InitRecorder();
	$.mobile.changePage( "#recordingPage", { transition: "none"} );
	g_shownPage='recording';
    //HideAd();
	
}

function ShowConfigPage(){
    $.mobile.changePage( "#configPage", { transition: "none"} );
	g_shownPage='config';
    //HideAd();

}
function ShowInfoPage(){
	$.mobile.changePage( "#infoPage", { transition: "none"} );
	g_shownPage='info';
    HideAd();
}
function ShowSharePage(){

	$.mobile.changePage( "#sharePage", { transition: "none"} );
	g_shownPage='share';
    //HideAd();
}
function ShowSettingsPage(){
    //HideAd();
	$.mobile.changePage( "#settingsPage", { transition: "none"} );
	g_shownPage='settings';
}
function ShowReportPage(){

	$.mobile.changePage( "#reportPage", { transition: "none"} );
	g_shownPage='report';
    //HideAd();
}
function SetMenuBar(_playMode){
	
	if(_playMode=="regional"){
		$('#btnPlayRegional').addClass('ui-btn-active');
	}
	else{
		$('#btnPlayRegional').removeClass('ui-btn-active'); 
	}
	if(_playMode=="none"){
		$('#btnPlayRegional').removeClass('ui-btn-active'); 
		$('#btnDisplayMap').removeClass('ui-btn-active'); 
		$('#btnDisplayList').removeClass('ui-btn-active'); 
        $('#btnRefresh').removeClass('ui-btn-active');
	}

}
function ShowUpdate(){
   $('#divUpdate').css('display','block'); 
}
function HideUpdate(){
    $('#divUpdate').css('display','none'); 

}
function SetUpdate(_date,_time){
	//Set update time
    var updatemessage = "Mise à jour: " + _date + " " + _time
    $('#divUpdate').text(updatemessage);
}
function ResetMenuBar(){
	
	$('#btnPlayRegional').removeClass('ui-btn-active'); 
	$('#btnDisplayMap').removeClass('ui-btn-active'); 
	$('#btnDisplayList').removeClass('ui-btn-active'); 
	$('#btnDisplayReport').removeClass('ui-btn-active');
    $('#btnRefresh').removeClass('ui-btn-active');

}
function CreateSegmentList(){
	var segList = '<option value="0">Route</option>]';;
	for(var i=0;i<segIndex;i++)
	{
		segList += '<option style="font-size:10px" value="'+(i+1)+'">'+segmentsList[i].route+" "+segmentsList[i].description+'</option>]';
	}
	$('#roadIDInfo').html(segList);
	//$('#roadIDInfo').val(0).selectmenu("refresh");
	
}
function SetPictureBtn(_status){
	if(_status==true)
		$('#btnAddPicture').css('color','blue');
	else{
		$('#btnAddPicture').css('color','white');
		var imgPlayer = document.getElementById('imagePlayer3');
		imgPlayer.src = GetPublicityImage(); //"css/images/logo_alerte511_fond_video.png";
	}
}
function SetFileBtn(_status){
	if(_status==true)
		$('#btnAddFile').css('color','blue');
	else{
		$('#btnAddFile').css('color','white');
		var imgPlayer = document.getElementById('imagePlayer3');
		imgPlayer.src = GetPublicityImage(); //"css/images/logo_alerte511_fond_video.png";
	}
}
function SetAudioBtn(_status){
	if(_status==true)
		$('#btnAddAudio').css('color','blue');
	else
		$('#btnAddAudio').css('color','white');
}
function getPhoneGapPath(){
    //'use strict';
    var path = window.location.pathname;
    var phoneGapPath = path.substring(0, path.lastIndexOf('/') + 1);
	//alert(phoneGapPath);
    return phoneGapPath;
}
function formatTime(hours,minutes,seconds){
	if (hours   < 10) {hours   = "0"+hours;}
    if (minutes < 10) {minutes = "0"+minutes;}
    if (seconds < 10) {seconds = "0"+seconds;}
    var time    = hours+':'+minutes+':'+seconds;
    return time;
}
function ResetAlertPage(){
		g_PictureLocalFilename=null;
		g_PictureRemoteFilename=null;

        g_AudioLocalFilename=null;
        g_AudioRemoteFilename = null;
		g_Audiofilename=null;
    
		//Clear Message error
		$('.divErrorVideo').css('display', 'none');
		
		//Disable audio play button
		$('#btnPlayAudio').addClass('ui-disabled');
		
		//Clear text area
		if(g_shownPage=='camera' ){
			var text = camerasMap[g_currentCamID].surname + "(" + camerasMap[g_currentCamID].route + ") "+camerasMap[g_currentCamID].description;
			$('#textareaInfo').val(text);
		}
		else
		{
			$('#textareaInfo').val("");
		}
		//Set avatar
		//var imgProfile = document.getElementById('alertAvatar');
		//if(g_userProfil!=0 && g_userProfil.avatar!=""){
		//	var path = g_serverID+g_dataDirectory + "/NETWORKS/"+g_curNetwork+"/USERS/"+g_userProfil.avatar;
		//	imgProfile.src = path;
		//}
		//else{
		//	imgProfile.src = "css/images/defaultUserIcon.png"
		//}
		
		//Set default alert icon
		$('#alertIcon #icon').attr('src', "css/images/circleWarning.png");
		g_alertType=0;
		$('#alertTypeMenu').css('display','none');
		
		//Set current time
		//var date = new Date();
		//$('#alertIcon #time').html(formatTime(date.getHours(),date.getMinutes(),date.getSeconds()));
		
		//Set  default image
		var imgPlayer = document.getElementById('imagePlayer3');
		if(g_shownPage=='camera'){
			imgPlayer.src = g_imageURL;
			g_PictureLocalFilename=g_imageLocal;
		}
		else
			imgPlayer.src = GetPublicityImage(); //"css/images/logo_alerte511_fond_video.png";
       // alert(g_PictureLocalFilename);
}
function BindMainEvents() {

	document.addEventListener('touchmove', function (e) { e.preventDefault(); }, false);
	$('#textareaInfo').keydown(function(e) {
		 if(e.keyCode == 13) {
		   e.preventDefault(); // Makes no difference
		 $(this).parent().submit(); // Submit form it belongs to
	   }
	});
	$(".inputclass").bind("blur", function(e) {
		window.scrollTo(0.0);
		//alert('close');
	});

 	$('#infoPage').on("pageshow", function() {
		//Set scroll for info
		if(g_Scroll1==0)
			setTimeout(function () {
				g_Scroll1 = new iScroll('wrapperScroll3');
			}, 0);
    });
 	$('#conditionsPage').on("pageshow", function() {
		//Set scroll for info
		if(g_Scroll2==0)
			setTimeout(function () {
				g_Scroll2 = new iScroll('wrapperScroll2');
                //HideAd();
			}, 0);
    });
	
	$('.userConditions').on("click", function() {
		//Get preveious page (either info or registering)
		$.mobile.changePage( "#conditionsPage", { transition: "none"} );
		
    });
	$('#btnBackConditions').on("click", function() {
		if(g_shownPage=='info')
			ShowInfoPage();
		else{
			ShowRegisterPage(null);
           // HideAd();
        }
		
    });	

  	$('#settingsPage').on("pageshow", function() {
		//Set username
		$('#profil_firstname').val(g_userProfil.firstname);
		//$('#profil_lastname').val(g_userProfil.lastname);
		//$('#profil_username').val(g_userProfil.username);
		$('#profil_email').val(g_userProfil.email);
		
		//if(g_userProfil.getnews=='true' || g_userProfil.getnews==true){
		//	$('#profil_getnews').prop('checked',true).checkboxradio('refresh');
		//}
		//else{
		//	$('#profil_getnews').prop('checked',false).checkboxradio('refresh');
		//}
		
		if(g_userProfil!=0 && g_userProfil.avatar!=""){
            
			//var path = g_serverID+g_dataDirectory + "/NETWORKS/"+g_curNetwork+"/USERS/"+g_userProfil.avatar;
            //alert(path);
			changeAvatar(g_userProfil.avatar);
		}
		else
			changeAvatar(null);
		
    });
	
	$('#mainPage').on("pageshow", function() {
	
		if(g_displayMode=='map')
			RefreshMap(false);
		else{
			//Refresh list
			RefreshList(true);
		}
    });
	$(document).one("mobileinit", function () {
        // Setting #bodyWrapper div as a jqm pageContainer
        $.mobile.pageContainer = $('#bodyWrapper');
 
 
    });

	$('#popupMenu').on("click", function() {
        $( "#popupMenu" ).panel( "close" );
    });	
	$('#popupMenu1').on("click", function() {
        $( "#popupMenu1" ).panel( "close" );
    });	
	$('#popupMenu2').on("click", function() {
        $( "#popupMenu2" ).panel( "close" );
    });	
	$('#popupMenu3').on("click", function() {
        $( "#popupMenu3" ).panel( "close" );
    });	
	$('#btnBackMap').on("click", function() {
		ShowPage('map');
		$( "#popupMenu" ).panel( "close" );

    });	
	
	$('#btnMainBackPrev').on("click", function() {
       ShowPrevPage();

    });	
	$('#btnBackPrev1').on("click", function() {
		ShowPrevPage();
    });
	$('#btnBackPrev').on("click", function() {
		ShowPrevPage();
    });
	$('#btnBackPrev2').on("click", function() {
		ShowPrevPage();
    });
	$('#btnBackPrev3').on("click", function() {
		ShowPrevPage();
    });
	

	$('#btnDisplayMap').on("click", function() {
		
		ShowPage('map');
		//$('#divTwitterWrapper').css('display','none');
		setTimeout(function(){RefreshMap(false);},250);
	});

	$('#btnDisplayList').on("click", function() {
		ShowPage('list');
        setTimeout(function(){RefreshList(true);},250);
		
		
	});
    $('#btnRefresh').on("click", function() {
        
        
        $('#btnRefresh').removeClass('ui-btn-active');
        //Fetch update from server
        setTimeout(function(){UpdateAll(true);},500); 
		
          
        		
	});
	$('#btnDisplayReport').on("click", function() {
		ValidateUser(function(){
			//Show report page
			//ResetAlertPage();
			ShowReportPage();

		},function(){
			ShowRegisterPage(function(){ShowReportPage();});
            //HideAd();
		});
	});
	$('#btnCameraShare').on("click", function() {
		ValidateUser(function(){
			//Show report page
			ResetAlertPage();
			//Show recording page
            ShowRecordingPage();
           

		},function(){
			ShowRegisterPage(function(){
                //Show report page
			     ResetAlertPage();
                //Show recording page
                ShowRecordingPage();
            }); 
            //HideAd();
		});
	});

	$('#btnStart').on("click", function() {
		//Display Loader
		ShowPage('map');
	});
	
	$('#btnDisplayInfo').on("click", function() {
		//Display Loader
		ShowInfoPage();
	});
	$('#btnShare').on("click", function() {
		//Display Loader
		//ShowSharePage();
		DisplayMainShare();
	});

	$('#btnSettings').on("click", function() {
		//Display option page
		ValidateUser(function(){
			ShowSettingsPage();
		},
		function(){
			ShowRegisterPage(function(){ShowSettingsPage();});
           // HideAd();
		});
		
	});
	$('#btnCancelPicture').on("click", function() {
		g_PictureLocalFilename=null;
		$("#btnCancelPicture").addClass('ui-disabled');

	});
				
	$('#btnAddPicture').on("click", function() {
		if(g_PictureLocalFilename==null || g_captureType=='file'){
			//DisplayLoader("Un moment svp!");
			capturePhoto();
		}
		else{
			g_PictureLocalFilename=null;
			SetPictureBtn(false);
		}
	});
	$('#btnAddFile').on("click", function() {
		if(g_PictureLocalFilename==null || g_captureType=='photo'){
			//DisplayLoader("Un moment svp!");
			captureFile();
		}
		else{
			g_PictureLocalFilename=null;
			SetFileBtn(false);
		}	
	});
	
	$('#btnCancelAudio').on("click", function() {
		g_AudioLocalFilename=null;
		g_Audiofilename=null;
		$("#btnCancelAudio").addClass('ui-disabled');
		
	});
	
	$('#btnAddText').on("click", function() {	
		$('#textareaInfo').focus();
	});
	
	$('#btnAddAlert').on("click", function() {
		$('#alertTypeMenu').css('display','block');
	});
	$('#btnWarning').on("click", function() {
			
		g_alertType=4;	
		$('#alertIcon #icon').attr('src',GetAlertCircle(g_alertType));
		$('#alertTypeMenu').css('display','none');

	});
	$('#btnAccident').on("click", function() {
			
		g_alertType=3;	
		$('#alertIcon #icon').attr('src',GetAlertCircle(g_alertType));
		$('#alertTypeMenu').css('display','none');

	});
	$('#btnSlowdown').on("click", function() {
			
		g_alertType=1;	
		$('#alertIcon #icon').attr('src',GetAlertCircle(g_alertType));
		$('#alertTypeMenu').css('display','none');

	});
	$('#btnCongestion').on("click", function() {
			
		g_alertType=2;	
		$('#alertIcon #icon').attr('src',GetAlertCircle(g_alertType));
		$('#alertTypeMenu').css('display','none');

	});
	$('#btnWorkzone').on("click", function() {
			
		g_alertType=5;	
		$('#alertIcon #icon').attr('src',GetAlertCircle(g_alertType));
		$('#alertTypeMenu').css('display','none');

	});
	$('#btnAccident').on("click", function() {
			
		g_alertType=3;	
		$('#alertIcon #icon').attr('src',GetAlertCircle(g_alertType));
		$('#alertTypeMenu').css('display','none');

	});
	
    $('#btnAddAudio').on("click", function() {

		//RecordAudio();		
	});	
	$('#btnPlayAudio').on("click", function() {
	
		//if(g_Audiofilename!=null)
		//	PlayAudio(g_Audiofilename,null);
		
		
	});
	$('#btnPublish').on("click", function() {
		if(CheckNbrAlert()==true){
			PublishAlert();
		}
		else{
			PopAlert("Vous avez atteint le nombre maximum de signalement  par mois ("+g_userProfil.nbrmaxalerts+"). Veuillez essayer plus tard.");
		}
	});	
	$('#select-period').on("change", function() {
		var value = $(this).val();
		if(value=="period-0")
			g_updatePeriod=0;
		else
		if(value=="period-0")
			g_updatePeriod=0;
		else
		if(value=="period-1")
			g_updatePeriod=1;
		else
		if(value=="period-5")
			g_updatePeriod=5;
		else
		if(value=="period-10")
			g_updatePeriod=10;
		else
		if(value=="period-15")
			g_updatePeriod=15;
		else
		if(value=="period-20")
			g_updatePeriod=20;
		else
		if(value=="period-25")
			g_updatePeriod=25;
		else
		if(value=="period-30")
			g_updatePeriod=30;
			
		//Restart update if activated
		RestartUpdateBulletin();
		//Set user setting on local storage
		SetUserSettings();			
    });	
    $('#select-avatar').on("change", function() {
		var value = $(this).val();
        var icon = document.getElementById('imgUserAvatar');
        if(value=="1")
			g_userProfil.avatar = "car1.png";
		else
        if(value=="2")
			g_userProfil.avatar = "car2.png";
		else
        if(value=="3")
			g_userProfil.avatar= "car3.png";
		else
        if(value=="4")
			g_userProfil.avatar = "car4.png";
		else
        if(value=="5")
			g_userProfil.avatar = "car5.png";
		else
        if(value=="6")
			g_userProfil.avatar = "car6.png";
		else
        if(value=="7")
			g_userProfil.avatar = "car7.png";
		else
        if(value=="8")
			g_userProfil.avatar = "car8.png";
		else
        if(value=="9")
			g_userProfil.avatar = "car9.png";
        icon.src = "./css/images/"+g_userProfil.avatar;
        g_userProfil.avatarModified=true;
    });	

    $('#btn-clear').bind('click', function() {
		ClearUserFavorite();
		PopAlert('Toutes vos Favorites ont été effacées');
	});
	$('#username').bind("keypress", function(e) {
		var username = $('#username').val();
		if(username.length>=10)
			return false;
		
	});
	$('#btnUserAvatar').bind('click', function() {
	
		captureProfilePicture();
		
	});
	$('#divUserCtrlPrevious').bind('click', function() {
		g_userIndex++;
		if(g_userIndex>=g_userMaxIndex){
			g_userIndex=g_userMaxIndex-1;
		}
		
		//Stop previos audio
		//StopRecordAudio();
		//Display alert preview
		ShowAlertPreview(g_userIndex);
		
		
	});
    $('#divUserCtrlMid').bind('click', function() {
		//Display user video alert
		//alert(g_videoURL);
		ShowUserVideoPreview(g_videoURL);
		
		
	});
	
	$('#divUserCtrlNext').on('click', function() {
		g_userIndex--;
		if(g_userIndex<0){
			g_userIndex=0;
		}
		
		//Stop previos audio
		//StopRecordAudio();
		//Display alert preview
		ShowAlertPreview(g_userIndex);
		
		
	});	
	$('#btnCancelProfil').on("click", function() {
		
        //ShowPrevPage();
        ShowPage('map');
		
	});
	$('#btnSendProfil').on("click", function() {
	
		
		//Get username
		g_userProfil.firstname = $('#profil_firstname').val();
		//g_userProfil.lastname = $('#profil_lastname').val();
		//g_userProfil.username = $('#profil_username').val();
		g_userProfil.email = $('#profil_email').val();
		//g_userProfil.getnews = $('#profil_getnews').prop('checked')?'true':'false';
		g_userProfil.defaultCity = getDefaultCity();
        console.log(g_userProfil.defaultCity);
		//play message end
		//RecordingPlayEnd();
		//Show previous page
		ShowPage('map');
        ModifyUser(GetUserID(),
                   g_userProfil.username,
                   g_userProfil.avatar,
                   g_userProfil.firstname,
                   g_userProfil.lastname,
                   g_userProfil.email,
                   g_userProfil.getnews,
                   g_userProfil.defaultCity,
                   null,null);
		//upload prodile
			//DisplayLoader("Un moment svp!");
		//if(g_userProfil.avatarModified==true && g_userProfil.avatar!=null && g_userProfil.avatar!="null" && g_userProfil.avatar!=""){
                
                
            //var ft = new FileTransfer();
			//uploadAvatarPicture(ft,g_userProfil.avatar,function(avatar){
					//Set user setting on local storage
			//		g_userProfil.avatar=avatar;
			//		g_userProfil.avatarModified=false;
					//ModifyUser(GetUserID(),g_userProfil.username,avatar,g_userProfil.firstname,g_userProfil.lastname,g_userProfil.email,g_userProfil.getnews,null,null);
		//	});
		//}
		////else{
			//ModifyUser(GetUserID(),g_userProfil.username,"",g_userProfil.firstname,g_userProfil.lastname,g_userProfil.email,g_userProfil.getnews,null,null);
		
		//}
		
		
	});
}
