
/* Audio player */
var g_audioRec=null;
var g_audioTimer = null;
var g_recordTimer = null;
var g_pausePos = 0;

var g_AudioLocalPath = null;
var g_AudioLocalFilename = null;
var g_AudioRemoteFilename = null;
var g_Audiofilename = null;
var g_fileext;
var g_uploadAudioStatus='end';
var g_uploadAudioTry=0;
var g_timerAudioHandle=0;
var g_cancelPlay=false;
var g_audioPlaying=false;
var g_audioRecorded=false;
var g_audioRecording=false;

function InitRecorder(){
    g_AudioLocalFilename=null;
    g_Audiofilename=null;
    SetAudioBtn('stop');
    
}
function StartRecording(){
    

    
	var localFileName;
	var srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/beep.mp3" ; 
	DownloadMP3ToLocalStorage(srcFilename,
		function(localPath){
			PlayAudio(localPath,function(){
                if(GetOSType()=='ios'){
                    localFileName = "user_message.wav";
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
                            //Start recording
                            fileSystem.root.getFile(localFileName, {create: true, exclusive: false}, 
                            function(fileEntry) {
                                SetAudioBtn("record");
                                g_AudioLocalFilename=fileEntry.toNativeURL();
                                startRecording(localFileName,".wav");

                            }, null);
                    });	
                }
                else{
                    var localDir = "com.alerte511";
                    localFileName = localDir+"/"+"user_message.mp3";
                    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem) {
                        fileSystem.root.getDirectory(localDir, {create: true}, function(dirEntry) {
                            //Start recording
                            fileSystem.root.getFile(localFileName, {create: true, exclusive: false}, 
                            function(fileEntry) {
                                var localPath = fileEntry.fullPath;
                                SetAudioBtn("record");
                                g_AudioLocalFilename=fileEntry.toNativeURL();
                                startRecording(localFileName,".mp3");								
                            }, null);
                        });
                    });	
                }
            },null);
		});
		
}
/* pause audio */
function AudioPlayIntro(_file) {

	$('#btnSendRecord').addClass('ui-disabled');
	var srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/record_message_beep.mp3" ; 
	DownloadMP3ToLocalStorage(srcFilename,
		function(localPath){
			PlayAudio(localPath,function(){
				$('#btnSendRecord').removeClass('ui-disabled');
				//Start recording
				if(GetOSType()=='ios')
					startRecording(_file,".wav");
				else
					startRecording(_file,".mp3");
			},null);
		});
}
function RecordingPlayEnd() {
	var srcFilename = g_serverID+g_dataDirectory+"/AUDIO/MP3/recording_end.mp3" ; 
	if(GetOSType()=='ios'){
		PlayAudio(srcFilename,null,null);
	}
	else
	if(GetOSType()=='android'){
		DownloadMP3ToLocalStorage(srcFilename,
			function(localPath){
				PlayAudio(localPath,null,null);
			});
	}
}
function PlayAudio(_file,_foo,_fError) {
	
	if(g_Version=='webapp'){
		if(_foo!=null) _foo.call();
	}
	if(g_audioPlaying==true)
		return;
	g_audioPlaying=true;
	g_audioRec = new Media(_file, function(){
        //alert('PlayAudio '+_file);
        
		g_audioRec.release();
		g_audioRec=null;
		g_audioPlaying=false;
		if(g_cancelPlay==false)
			if(_foo!=null) _foo.call();
		
	}, 
	function(error){ // error callback
		//alert('code: '    + error.code    + '\n' +
         //     'message: ' + error.message + '\n');
        
		g_audioPlaying=false;
		if(_fError!=null) _fError.call();
	});
	//alert('PlayAudio '+_file);
	
	g_audioRec.play();
	g_cancelPlay=false;
 }
/* stop audio */
function stopAudio() {
    g_pausePos = 0;
    g_cancelPlay=true;
	if (g_audioRec) {
        g_audioRec.stop();

    }

}

/* set audio position */
function setAudioPosition(position) {
	g_pausePos = position;
	position = Math.round(position);
    //$('#slider').val(position);
   // $('#slider').slider('refresh');
}

/* record audio file */
function startRecording(_file,_ext){

	g_Audiofilename=_file;
	g_fileext=_ext;
	
    g_audioRecording=true;
	//alert('startRecording '+g_Audiofilename);
	g_audioRec = new Media(g_Audiofilename, function(){
			//alert('Recording Success');
			//this.seekTo(0);
			//this.play();
			g_audioRec.release();
			g_audioRec=null;
			//$('#btnPlayAudio').removeClass('ui-disabled');
	        g_audioRecorded=true;
            g_audioRecording=false;
			//alert('Recording Success');
			//alert(g_Audiofilename);
			//PlayAudio(g_Audiofilename,null);

		}, 
		function(error){ // error callback
			//alert('code: '    + error.code    + '\n' +
            //      'message: ' + error.message + '\n');
		//g_audioRec.stopRecord();
    	//g_audioRec.release();
		//startRecording(_file,".wav");
            g_audioRecording=false;
		});
	
    // start recording
	g_audioRec.startRecord();
    //alert('startRecord');

	// stop recording after 60 seconds
	if(g_audioRec!=null){
		g_recordTimer = setTimeout(function(){
			//alert("Timeout");
            g_audioRecording=false;
			stopRecording();
			//Show main page
			ShowPrevPage();
		}, 60000);
	}
	
}
/* stop audio */
function stopRecording() {
    SetAudioBtn('stop');
    if (g_audioRec!=null) {
		//alert('stopRecord');
        g_audioRec.stopRecord();
    	//g_audioRec.release();
		//g_audioRec=null;
    }
	if(g_recordTimer!=null)
		clearTimeout(g_recordTimer);
    g_recordTimer = null;
	
}
function uploadAudioFile(_ft,_file,_foo,_timerHandle) {

	//alert('uploadAudio '+_file);
	if(_file==null){
		g_uploadAudioStatus='end';
		if(_foo!=null) _foo.call();
		return;
	}
	
	var urlExt = g_serverID+"phpservices/UploadAudio.php";
	var path ='/'+g_dataDirectory+"/NETWORKS/"+g_curNetwork+g_msgFolder;
	//var localPath = fileEntry.toNativeURL();
	//alert(urlExt+ ' '+path+' '+_file);
	//Set uplaod options

	options = new FileUploadOptions();
	options.fileKey="file";
	options.fileName=_file.substr(_file.lastIndexOf('/')+1);
	if(g_fileext==".wav")
		options.mimeType="audio/vnd.wav";
	else
		options.mimeType="audio/mpeg";

	params = new Object();
	params.value1 = path;
	options.params = params;
	options.chunkedMode=false;
	options.headers={"Connection":"close"};
	
	//Upload file to server
	
	g_uploadAudioStatus='start';
	
	_ft.onprogress = function(progressEvent){
		//Clear reset timer
		//Restart if nothing happens
		if(g_uploadAudioTry==0){
			var loaded_ratio = progressEvent.loaded/progressEvent.total;
			//alert('Audio ' + loaded_ratio);
			g_uploadAudioTry=1;
			g_timerAudioHandle = setTimeout(function(){
				_ft.abort();
				uploadAudioFile(_ft,_file,_foo); 
			},2000);
		}
	};
	_ft.upload(_file, urlExt, function(r){
		if(g_timerAudioHandle!=0)
			clearTimeout(g_timerAudioHandle);
		g_timerAudioHandle=0;
		//alert('Audio '+r.response +' Code '+r.responseCode);
		g_AudioRemoteFilename = r.response;
		g_uploadAudioStatus='end';

		if(_foo!=null) _foo.call();
		
	}, uploadAudioFailed, options,true);
}

function uploadAudioSuccess(r) {

	g_AudioRemoteFilename = r.response;
	g_uploadAudioStatus='end';
	//alert("AudioFile = " +g_AudioRemoteFilename);
	//remove local file
	if(g_AudioLocalFilename!=null)
		fileEntry.remove(g_AudioLocalFilename,removeAudioSuccess,null);
}
function removeAudioSuccess(error) {
	//alert("Removed" + g_AudioLocalFilename);
	
}
function uploadAudioFailed(error) {
	g_disableRefresh=true;
	 var msgText;
	 switch(error.code) {
	 case FileTransferError.FILE_NOT_FOUND_ERR:
		msgText = "File not found.";
	 break;
	 case FileTransferError.INVALID_URL_ERR:
		msgText = "Invalid URL.";
	 break;
	 case FileTransferError.CONNECTION_ERR:
		msgText = "Connection error.";
	 break;
	 default:
		msgText = "Unknown error.";
	}
	//Now tell the user what happened
	//if(g_uploadAudioTry==1)
		//alert(msgText+' SRC '+error.source+" TARGET " + error.target+" CODE " + error.code);
}

function dummyUpload(_file){


	var urlExt = g_serverID+"phpservices/UploadAudio.php";
	g_fileTransfer.upload(_file, urlExt, null, dummyError);
	
}

function dummyError(error) {
	//alert("Dummy error : Code = " + error.code);
	//console.log("upload error source " + error.source);
	//console.log("upload error target " + error.target);
}
function SetAudioBtn(_type){
    if(_type=='record'){
        $('#btnStopRecord').removeClass('ui-disabled');   
        $('#btnPlayRecord').addClass('ui-disabled');   
        $('#btnStartRecord').addClass('ui-disabled');   
    }
    else
    if(_type=='play'){
        $('#btnStopRecord').removeClass('ui-disabled');   
        $('#btnPlayRecord').addClass('ui-disabled');   
        $('#btnStartRecord').addClass('ui-disabled');   
    }   
    else
    if(_type=='stop' && g_Audiofilename==null){
        $('#btnStopRecord').removeClass('ui-disabled');   
        $('#btnPlayRecord').addClass('ui-disabled');   
        $('#btnStartRecord').removeClass('ui-disabled');   
    }   
    else
    if(_type=='stop' && g_Audiofilename!=null){
        $('#btnStopRecord').removeClass('ui-disabled');   
        $('#btnPlayRecord').removeClass('ui-disabled');   
        $('#btnStartRecord').removeClass('ui-disabled');   
    }   
}
function BindRecorderEvents() {

    
	$('#btnCancelRecord').on("click", function() {
		//SetAudioBtn(false);
		g_AudioLocalFilename=null;
		g_Audiofilename=null;
		//Stop recording 
		stopRecording();
		//Show main page
        ShowPage('map');

	});
    $('#btnStopRecord').on("click", function() {
        //Stop audio if playing
        if(g_audioPlaying==true)
           stopAudio();  
        else
        if(g_audioRecording==true)
		  //Stop recording 
		  stopRecording();
    });
    $('#btnStartRecord').on("click", function() {
		g_AudioLocalFilename=null;
		g_Audiofilename=null;
        StartRecording();
    });
    $('#btnPlayRecord').on("click", function() {
        //Play record
        SetAudioBtn('play');
        PlayAudio(g_Audiofilename,SetAudioBtn("stop"));
    });  
    
    $('#btnSendImage').on("click", function() {

		//Stop recording 
		stopRecording();

		//Show main page
        ShowPage('map');
        
        //Publish alert
        if(g_AudioLocalFilename==null)
            PublishCameraAlert();
        else
            PublishAlert();
		
	});
    
	
}
